var DataExchange = {
	commonAjax: function( tip, type, options, hasData, dataStr ) {
		if ( tip && Object.prototype.toString.call( tip ).toLowerCase() === "[object string]" ) {
			DataExchange[ tip ]();
		}
		var url = options.url,
			ajaxOps;
		delete  options.url;
		ajaxOps = {
			url: WEB_TOOLS_URL + url,
			type: type,
			dataType: 'json',
			data: hasData ? ( dataStr ? options[ dataStr ] : options ) : {}
		};
		if ( type === "get" || !hasData ) {
			delete  ajaxOps.data;
		}
		console.log(ajaxOps);
		return $.ajax( ajaxOps );
	},
	commonPost: function(tip,options, hasData, dataStr) {
		return this.commonAjax(tip, 'POST', options, hasData, dataStr)
			.fail( this.ajaxFailureHandler )
			.done( this.ajaxDoneHandler );

	},
	commonGet: function(tip,url) {
		return this.commonAjax(tip,'get',{ url: url })
			.fail( this.ajaxFailureHandler )
			.done( this.ajaxDoneHandler );
	},

	ajaxDoneHandler: function(json) {
		Widget.popupLoadingClose();
		if ( !json.success ) {
			Widget.popupToast( json.errMsg );
		}
	},

	ajaxFailureHandler: function(jqXHR, textStatus, errorThrown) {
		Widget.popupLoadingClose();
		if (navigator.network.connection.type === Connection.NONE) {
			Util.alert('无网络连接，请检查您的设置！');
		} else {
			Util.alert('网络异常，请稍候重试...');
		}
	},
	upInfo: function(){
		Widget.popupLoading('正在上传数据中...');
	},
	getInfo: function(){
		Widget.popupLoading('正在获取数据中...');
	},
	delInfo: function(){
		Widget.popupLoading('正在删除数据中...');
	},
	sendCode: function(){
		Widget.popupLoading('验证码正在到达途中..');
	},
	up: 'upInfo',
	get: 'getInfo',
	del: 'delInfo',
	send: 'sendCode',

	//----------------------------健康工具
	getYgzcResult: function(options){
		options.url = '/resident/tools/hbselftest';
		return this.commonPost(this.get,options, true, 'data');
	},
	getPredictedBabyBloodType: function(options){
		options.url = '/resident/tools/babyBlood';
		return this.commonPost(this.get,options, true, 'data');
	},
	addTcmPhysicalTest: function(options){
		options.url = '/resident/tcm/physicalSelfTestsResult';
		return this.commonPost(this.up,options, true, 'data');
	},
	getTcmPhysicalTestHistory: function(options){
		options.url = '/resident/tcm/memberPhysicalSelf';
		return this.commonPost(this.get,options, true, 'data');
	},
	getCheckTestItems: function(options){
		options.url = '/resident/tools/checklistitems';
		return this.commonPost(this.get,options, true, 'data');
	},
	getCheckTestItemsByName: function(options){
		options.url = '/resident/tools/checklistitems';
		return this.commonPost(this.get,options, true, 'data');
	},
	getCheckTestDetailItem: function(options){
		options.url = '/resident/tools/checklistitems/itemcontent';
		return this.commonPost(this.get,options, true, 'data');
	}
};