/**
 * Created with IntelliJ IDEA.
 * User: cfl
 * Date: 14-7-21
 * Time: 下午3:57
 * To change this template use File | Settings | File Templates.
 */
Views.aboutUsView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'aboutUsView',
		name: '关于我们'
	},
	willShow: function(ct) {
		this.render(ct);
		this.loadData();
	},
	loadData: function() {
		var self = this;
		if (APPVERSION === 'web') {
			setTimeout(function(){
				$('.ui-us').html(TestSuit.getAboutUsHtml());
				self.makeScrollable($('#pageScrollerWrapper'));
			}, 1000);
			return;
		}
		var data = Util.data('hospitalNote.ABOUT_US'),
			now = new Date() - 0,
			lastTime = Util.data('hospitalNote.ABOUT_US.time');

		if (APPVERSION !== 'product' || !data || now - lastTime > Util.MILLIS_1_DAY) {
			var updateTime = Util.data('hospitalNote.ABOUT_US.updateTime') ? Util.data('hospitalNote.ABOUT_US.updateTime') : '';
			FuckHttp.loadHospitalNote({
				data: {type: 'ABOUT_US', updateTime: updateTime},
				doneError: function() {},
				success: function(json) {
					if (json.data && json.data.content) {
						Util.data('hospitalNote.ABOUT_US', json.data.content);
						Util.data('hospitalNote.ABOUT_US.time', new Date() - 0);
						Util.data('hospitalNote.ABOUT_US.updateTime', json.data.updateTime);
						setTimeout(function(){
							$('.ui-us').html(json.data.content);
							self.makeScrollable($('#pageScrollerWrapper'));
						}, 500);
						return;
					}
					if (data) {
						setTimeout(function() {
							$('.ui-us').html(data);
							self.makeScrollable($('#pageScrollerWrapper'));
						}, 500)
					}
				},
				error: function() {
					if (data) {
						setTimeout(function() {
							$('.ui-us').html(data);
							self.makeScrollable($('#pageScrollerWrapper'));
						}, 500)
					}
				}
			});
			return;
		}
		setTimeout(function() {
			$('.ui-us').html(data);
			self.makeScrollable($('#pageScrollerWrapper'));
		}, 500)
	}
});

Callback.checkAppVersion = function() {
	Util.checkVersionUpdate(true);
};

Views.disclaimerView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'disclaimerView',
		name: '免责声明'
	},
	willShow: function(ct) {
		this.render(ct);
		this.loadData();
	},
	loadData: function() {
		var self = this;
		if (APPVERSION === 'web') {
			setTimeout(function(){
				TestSuit.getHtml('disclaimer.txt', function(rs) {
					$('#pageScrollerWrapper').find('.ui-scroller').html(rs);
					self.makeScrollable($('#pageScrollerWrapper'));
				});
			}, 1000);
			return;
		}
		var data = Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER'),
			now = new Date() - 0,
			lastTime = Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER.time');

		if (APPVERSION !== 'product' || !data || now - lastTime > Util.MILLIS_1_DAY) {
			var updateTime = Util.data(HOSPITAL_ID+ '.hospitalNote.DISCLAIMER.updateTime') ? Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER.updateTime') : '';
			FuckHttp.loadHospitalNote({
				data: {type: 'DISCLAIMER', updateTime: updateTime},
				doneError: function() {},
				success: function(json) {
					if (json.data && json.data.content) {
						Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER', json.data.content);
						Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER.time', new Date() - 0);
						Util.data(HOSPITAL_ID + '.hospitalNote.DISCLAIMER.updateTime', json.data.updateTime);
						setTimeout(function(){
							$('#pageScrollerWrapper').find('.ui-scroller').html(json.data.content);
							self.makeScrollable($('#pageScrollerWrapper'));
						}, 500);
						return;
					}
					if (data) {
						setTimeout(function(){
							$('#pageScrollerWrapper').find('.ui-scroller').html(data);
							self.makeScrollable($('#pageScrollerWrapper'));
						} ,500);
					}
				},
				error: function() {
					if (data) {
						setTimeout(function(){
							$('#pageScrollerWrapper').find('.ui-scroller').html(data);
							self.makeScrollable($('#pageScrollerWrapper'));
						} ,500);
					}
				}
			});
			return;
		}
		setTimeout(function(){
			$('#pageScrollerWrapper').find('.ui-scroller').html(data);
			self.makeScrollable($('#pageScrollerWrapper'));
		} ,500);
	}
});

// ------------------------- 意见反馈 > feedbackView
Views.feedbackView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'feedbackView',
		name: '意见反馈'
	},
	willShow: function(ct) {
		if( UserProfile.isUserLoggedIn() ) {
			this.render(ct,{
				inputWidth: Layout.windowWidth-48,
				mobile: UserProfile.code
			});
		} else {
			this.render(ct,{
				inputWidth: Layout.windowWidth-48,
				mobile: ''
			});
		}
	},
	submit: function(param) {
		if ( APPVERSION === 'web' ) {
			Callback.pageBack();
			Widget.popupToast('反馈已经提交');
		} else {
			param.deviceId = DEVICE_UUID;
			param.version = VERSION_NUMBER;
			param.hospitalId = HOSPITAL_ID;
			FuckHttp.submitFeedback({
				data: param,
				success: function(json) {
					Callback.pageBack();
					Widget.popupToast('反馈已经提交');
				}
			});
		}
	}
});
Callback.submitFeedBack = function(btnId) {
	var content = $("#feedContext").val(),
		contact = $("#contact").val();

	if (!content) {
		Util.alert("请填写反馈信息");
		return;
	}

    if(!contact) {
        Util.alert(Views.errorMsg.NO_MOBILE);
        return;
    }else if(!Validator.stringIsMobileNo(contact)){
        Util.alert(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
	if (content.length > 250) {
		Util.alert("反馈信息不能超过250个字");
		return;
	}

	//之后再加上联系方式的判断

	Views.feedbackView.submit({
		phoneNum: contact,//都已昵称先代替
		content: content
	});
};

// ------------------------- 问题列表 > problemsListView
Views.problemsListView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'problemsListView',
		name: '常见问题'
	},
	willShow: function(ct) {
		if (APPVERSION === 'web') {
			this.render(ct, {data: TestData.faqData});
			return;
		}
		var data = Util.data('faq.data'),
			lastTime = Util.data('faq.time'),
			now = new Date() - 0,
			self = this;
		if (APPVERSION !== 'product' || !lastTime || now - lastTime > Util.MILLIS_1_DAY || !data) {
			FuckHttp.getFaq({
				success: function(json) {
					self.render(ct, {data: json.data});
					Util.data('faq.data', json.data);
					Util.data('faq.time', new Date() - 0);
				}
			});
			return;
		}
		this.render(ct, {data: data});
	}
});

Callback.showFaqDetail = function(btnId) {
	var subject = $('#' + btnId).attr('data-subject');
	var data = Util.data('faq.data'),
		items;
	for (var i = 0; i < data.length; i++) {
		if (subject === data[i].subject) {
			items = data[i].questionList;
		}
	}
	if (!items) {
		return;
	}
	Util.data('faq.detail', {subject: subject, items: items});
	StageManager.pushView(Views.commonProblemsView);
};

// ------------------------- 问题内容 > commonProblemsView
Views.commonProblemsView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'commonProblemsView',
		name: '问题内容'
	},
	willShow: function(ct) {
		var data = Util.data('faq.detail');
		this.render(ct,{data: data});
	},
	didShow: function() {
		this.makeScrollable($('#commonProblems'));
	}
});

Callback.openUrl = function(btnId){
    var url = $('#'+btnId).attr('data-rel');
    window.open(url, '_system');
};
