// ------------------------- 家庭成员列表 > memberListView
//
Views.memberListView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'memberListView',
		name: '家庭成员列表'
	},
	willShow: function(ct) {
		var memberList = [];
		if( APPVERSION === 'web' ) {
			memberList = TestData.userProfile.accounts;
		} else {
			memberList = UserProfile.accounts;
		}

		this.container = ct;
		this.render(ct,{
			scrollerHeight: (memberList.length+1)/2*125,
			members: memberList,
            mode: 'page'
		});
        var self = this;
        this.makeScrollableWithPullRefresh($('#memberListScroller'),{
            onPullUpRefresh: function() {
                Widget.popupToast('onPullUpRefresh');
            },
            onPullDownRefresh: function() {
                CACHE.ajaxMembers(function(data) {
                    self.render($('.member-list'), {
                        scrollerHeight: (data.length+1)/2*125,
                        members: data,
                        mode: 'dropDown'
                    });
                });
                CACHE.ajaxCards();
            }
        });
	}
});


Callback.turnToEditPerInfo = function(btnId) {
    var _btn = $('#'+btnId), input_type = 'text', hint = '',
        member_item = _btn.attr('data-rel') ,
        type =   _btn.attr('data-type'),
        title = _btn.find('.left-label').html() ? _btn.find('.left-label').html() :  _btn.find('.left').html() ,
        value = _btn.find('.right-input').html(),
        member = Util.data('cache.personalInfo');
        Util.data('contactType',type);
    if(member_item === 'paperNo'){
        value = member.paperNo;
    }

    switch(member_item) {
        case 'mobile':
            input_type = 'tel';
            hint = '请输入常用手机号码';
            break;
        case 'name':
            input_type = 'text';
            hint = '请填写真实姓名';
            break;
        case 'paperNo':
            input_type = 'text';
            hint = '请输入证件号码';
            break;
        case 'address':
            input_type = 'textarea';
            hint = '请输入少于80字';
            break;
        case 'birthday':
            input_type = 'sel_date';
            hint = '点击选择出生日期';
            break;
        case 'sex':
            input_type = 'sel_sex';
            hint = '请选择性别';
            break;
        case 'paperType':
            input_type = 'sel_paperType';
            hint = '请选择证件类型';
            break;
        case 'medicalCardNo':
            input_type = 'text';
            hint = '请输入'+Util.data('cardSelectType');
            break;
        case 'verifycode':
            input_type = 'text';
            hint = '请输入验证码';
            break;
        case 'idCard':
            input_type = 'text';
            hint = '请输入身份证号码';
            break;
        case 'ward':
            input_type = 'text';
            hint = '请输入病区';
            break;
        case 'sickbed':
            input_type = 'text';
            hint = '请输入病床号';
            break;
    }
    if(member_item === 'verifycode' && !member.medicalCardNo){
        Widget.popupToast('请先输入'+ Util.data('cardSelectType'))
        return;
    }
    if(member_item === 'paperType') {
        var paperTypes = Util.data('paperTypes');
        Util.data('memberEditItemView.show.data',{
            type: member_item,
            title: title,
            val: value,
            input_type: input_type,
            hint: hint,
            types: paperTypes
        });
        StageManager.pushView(Views.memberEditItemView);
        return;
    }
	Util.data('memberEditItemView.show.data',{
		type: member_item,
		title: title,
		val: value,
		input_type: input_type,
		hint: hint
	});
	StageManager.pushView(Views.memberEditItemView);
};
// ------------------------- 添加家庭成员 > memberAddView
//
Callback.showAddmember = function(btnId, type) {

    var  member =  Util.data('cache.personalInfo');
    var member = {
        sex: "MALE",
        paperType: "身份证"

    };
    var cardTypes = Util.data('cache.cardTypes'), rel;
    if(btnId){
        rel = $('#'+btnId).attr('data-rel');
    }else {
        rel = type;
    }

    if(rel && rel === '住院号'){
        for(var i = 0; i< cardTypes.length; i++){
            if(cardTypes[i].name === '住院号'){
                member.medicalCardTypeId = cardTypes[i].id;
                member.codeType = 2;
                break;
            }
        }
    }else{
        member.codeType = 1;
        rel = '就诊卡';
    }
    Util.data('cardSelectType', rel);
	Util.data('cache.personalInfo', member);
	StageManager.pushView(Views.memberAddView);
};
Views.memberAddView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'memberEditView',
		name: '添加持卡人'
	},
	willShow: function(ct) {
		var member = Util.data('cache.personalInfo');
        var allCards = Util.data('cards')||[], cards = [];
        if( allCards && allCards.length > 0 ) {
            for( var i=0;i<allCards.length;i++ ) {
                if( allCards[i].patientId-0 === member.id-0 ) {
                    cards.push(allCards[i]);
                }
            }
        }
        if(!Util.data('cardSelectType')){
            Util.data('cardSelectType', '就诊卡');
        }
        if(member && member.id) {
            this.render(ct,{
                title: '编辑持卡人',
//                callbackSubmit: 'editMemberSubmit',
                callbackSubmit: 'showAddCard2',
                needDel: true,
                member: member,
                cards: cards,
                memberInfoType: Util.data('cardSelectType')
            });
        } else {
            this.render(ct,{
                title: '添加持卡人',
//                callbackSubmit: 'addMemberSubmit',
                callbackSubmit: 'showAddCard2',
                needDel: false,
                member: member,
                cards: cards,
                memberInfoType: Util.data('cardSelectType')
            });
        }
		this.makeScrollable($('#personal-info'));
        if(!member.id || member.id === 0){
            $('.item.need-change').addClass('ui-btn');
            $('.item.need-change .right-arrow').show();
            $('.need-hide').show();
        }else{
            $('.item.need-change').removeClass('ui-btn');
            $('.item.need-change .right-arrow').hide();
            $('.need-hide').hide();
        }
	},
    addMemberSubmit: function(member) {
        if( APPVERSION === 'web' ) {
            Widget.popupSuccess('新增持卡人成功！');
        } else {
            var data = $.extend({}, member);
            var paperTypes = Util.data('paperTypes');
            data.isFamilyMember=true;
            data.accountId=UserProfile.id;
            data.paperType = CACHE.getPaperChangeValueAndKeyTypes()[data.paperType];

            Widget.popupLoading('正在提交数据...');

            FuckHttp.addMember({
                data: data,
                success: function(json) {
                    if(!json.success) {
                        Util.alert(json.errMsg);
                    } else {
                        UserProfile.refreshAccounts(json.data);
                        for(var i = 0; i < json.data.length; i++) {
                            if(member.name === json.data[i].name && member.mobileNo === json.data[i].mobileNo){
                                member = json.data[i];
                            }
                        }
                        UserProfile.setCurrentMember(member);
                        Util.data('cache.personalInfo',member);

                        $('.ui-header-title').html('编辑持卡人');
                        $('.ui-header-submit').attr('data-action', 'editPerInfoSubmit');
                        $('#deleteBtn').show();
                        Widget.popupSuccess(json.errMsg);
                    }
                },
                doneError: function(json) {
                    Widget.popupLoadingClose();
                    Util.alert(json.errMsg);
                }
            });
        }
    }
});
Callback.addMemberSubmit = function() {
	var member = Util.data('cache.personalInfo');
    if( !member ) {
        Widget.popupToast('请填写新成员信息!');
        return;
    }
    if( !member.name ) {
        Widget.popupToast('请填写真实姓名!');
        return;
    }
    if( !member.paperType ) {
        Widget.popupToast('请选择证件类型!');
        return;
    }
    if( member.paperType !== '无身份证' && !member.paperNo ) {
        Widget.popupToast('请填写证件号码!');
        return;
    }
    if( member.paperType === '身份证' && !Validator.stringIsIdCard(member.paperNo)){
        Widget.popupToast('您输入的身份证号码有误！');
        return;
    }
    if( !member.mobileNo ) {
        Widget.popupToast('请填写手机号码!');
        return;
    }
    if(CACHE.checkMemberIsExist(member)){
        Widget.popupToast('您新增的持卡人已存在！');
        return;
    }
    Views.memberAddView.addMemberSubmit(member);
};
// -------------------------  编辑成员
//
Callback.showEditMember = function(btnId) {
	var id = $('#'+btnId).attr('data-rel'),
        info = $('#'+btnId).attr('data-info'),
        member = UserProfile.getMemberById(id);
       var contacts = Util.data('contacts');
    if(info){
        for(var i = 0 ; i < contacts.length ; i++ ){
            if(contacts[i].id == id){
                Util.data('personalInfo',contacts[i]);
                StageManager.pushView(Views.updateContactsView);
            }
        }
    }else{
        if( member ) {
            Util.data('cache.personalInfo',member);
            StageManager.pushView(Views.memberEditView);
        }
    }


};
Views.memberEditView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'memberEditView',
		name: '编辑持卡人'
	},
	willShow: function(ct) {
		var member = Util.data('cache.personalInfo');
        var allCards = Util.data('cards'), cards = [];
        if(APPVERSION === 'web') {
            allCards = TestData.medicalCards;
            Util.data('cards', allCards);
        }
        if( allCards && allCards.length > 0 ) {
            for( var i=0;i<allCards.length;i++ ) {
                if( allCards[i].medicalCardValid && allCards[i].patientId-0 === member.id-0 ) {
                    cards.push(allCards[i]);
                }
            }
        }

        if(!Util.data('cardSelectType')){
            Util.data('cardSelectType', '就诊卡');
        }

		this.render(ct,{
            title: '编辑持卡人',
            callbackSubmit: 'editMemberSubmit',
            needDel: true,
			member: member,
            cards: cards,
            memberInfoType: Util.data('cardSelectType')
		});
        if(!member.id || member.id === 0){
            $('.item.need-change').addClass('ui-btn');
            $('.item.need-change .right-arrow').show();
            $('.need-hide').show();
        }else{
            $('.item.need-change').removeClass('ui-btn');
            $('.item.need-change .right-arrow').hide();
            $('.need-hide').hide();
        }
		this.makeScrollable($('#personal-info'));
	},
    deleteMember: function(member) {
        Widget.popupLoading("正在删除...");
        if (APPVERSION === 'web') {
            Widget.popupLoadingClose();
            Util.alert('删除成功！');
            Callback.pageBack();
        } else {
            FuckHttp.deleteMember({
                memberId: member.id,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if ( !json.success ) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    UserProfile.deleteMember(member.id);
                    UserProfile.deleteCard(member.medicalCardNo);
                    CACHE.ajaxCards();//刷新就诊卡数据
                    Util.alert('删除成功！');
                    Callback.pageBack();
                }
            });
        }
    },
    submitMember: function() {
        if( APPVERSION === 'web' ) {
            Widget.popupSuccess('修改持卡人成功！');
        } else {
            var member = Util.data('cache.personalInfo'), data = $.extend({}, member);
            delete data.medicalCards;
            data.isFamilyMember = true;
            data.accountId = UserProfile.id;
            data.paperType = CACHE.getPaperChangeValueAndKeyTypes()[data.paperType];
            Widget.popupLoading('正在提交数据...');
            FuckHttp.submitMember({
                data: data,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if(!json.success) {
                        Util.alert(json.errMsg);
                    } else {
                        UserProfile.refreshAccounts(json.data);
                        Util.data('members', json.data);

                        for(var i = 0; i < json.data.length; i++) {
                            if(member.name === json.data[i].name && member.mobileNo === json.data[i].mobileNo){
                                member = json.data[i];
                            }
                        }
                        UserProfile.setCurrentMember(member);
                        Util.data('cache.personalInfo',member);
                        Widget.popupSuccess(json.errMsg);
//                        CACHE.ajaxCards();//刷新就诊卡数据
                    }
                }
            });
        }
    }
});
Callback.editMemberSubmit = function() {
    var member = Util.data('cache.personalInfo');
    if( !member.name ) {
        Widget.popupToast('请填写真实姓名!');
        return;
    }
    if( !Validator.stringIsRealName(member.name) ) {
        Widget.popupToast('姓名处请输入2~5个中文字符！');
        return;
    }
    if( !member.paperType ) {
        Widget.popupToast('请选择证件类型!');
        return;
    }
    if( member.paperType !== '无身份证' && !member.paperNo ) {
        Widget.popupToast('请填写证件号码!');
        return;
    }
    if( member.paperType === '身份证' && !Validator.stringIsIdCard(member.paperNo)){
        Widget.popupToast('您输入的身份证号码有误！');
        return;
    }
    if( !member.mobileNo ) {
        Widget.popupToast('请填写手机号码!');
        return;
    }
    if( !Validator.stringIsMobileNo(member.mobileNo) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    if(CACHE.checkMemberIsRepeate(member)){
        Widget.popupToast('您修改后的持卡人已存在！');
        return;
    }
    Views.memberEditView.submitMember();
};
Callback.deleteMember = function() {
    var member = Util.data('cache.personalInfo');
    var type = Util.data('cardSelectType');
    Util.confirm('确定删除该'+type+'？', function(index) {
        if (index === 2) {
            Views.memberEditView.deleteMember(member);
        }
    });
//    if( UserProfile.findCardsNumByMember(member.id) > 0 ) {
//        Util.confirm('该持卡人的就诊卡和住院号也会删除，是否继续？', function(index) {
//            if (index === 2) {
//                Views.memberEditView.deleteMember(member);
//            }
//        });
//    } else {
//        Util.confirm('您确定要删除该持卡人吗？', function(index) {
//            if (index === 2) {
//                Views.memberEditView.deleteMember(member);
//            }
//        });
//    }
};
Callback.hideNextAll = function(btnId) {
    var el = $('#' + btnId);
    var items = el.nextAll();
    var arrow = $('.up-arrow', el);
    if(arrow.length > 0) {
        arrow.removeClass('up-arrow').addClass('down-arrow');
        items.hide(350);
    }else{
        arrow = $('.down-arrow', el);
        arrow.removeClass('down-arrow').addClass('up-arrow');
        items.show(350);
    }
};

// ------------------------- 填写家庭成员 > memberEditItemView
//
Views.memberEditItemView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'memberEditItemView',
		name: '填写家庭成员'
	},
	willShow: function(ct) {
		var data = Util.data('memberEditItemView.show.data'), member = Util.data('cache.personalInfo');

		data.mobile = mobile_system;
		this.render(ct, data);
		if( data.input_type === 'sel_date' ) {
			Callback.showDateMobiscroll(data.type);

            if( !member.birthday ) {
                $('#birthday').val(DateUtil.formatWithPatternDate('yyyy-mm-dd', new Date()));
            }
		}
		Util.bindForInputClearBtn($('input[type="text"],input[type="tel"]'));
	},
    didShow: function(ct){
        setTimeout(function(){
            $('.right-input input', ct).focus();
        }, 200)

    },
    submit: function() {
        var data = Util.data('memberEditItemView.show.data'), 
            type = data.type,
            info  = Util.data('personalInfo') ? Util.data('personalInfo') : [] ,
            member = Util.data('cache.personalInfo');

        if( type === 'sex' ) {
            if($('#sexMale').find('.sex-sel').hasClass('sel')) member.sex = 'MALE';
            if($('#sexFemale').find('.sex-sel').hasClass('sel')) member.sex = 'FEMALE';
        } else if (type === 'paperType'){
            if ($('.sex-sel.sel').length === 0) {
                Widget.popupToast('请选择证件类型！');
                return;
            }
            var newPaperType = $('.sex-sel.sel').prev().html();
            if(member.paperType !== newPaperType){
                member.paperNo = '';
            }
            member.paperType = newPaperType;

        } else {
            var val = $('#'+type).val();
            if( this.validate(type, val) ) {
                member[type] = val;
                info[type] = val ;
                //身份证带出生日、性别、年龄
                if( (type === 'paperNo' && member.paperType === '身份证') ||  type === 'idCard') {
                    var briAndSex = Validator.isChinaId(val);
                    if ( briAndSex[0] ) {
                        member.birthday = briAndSex[1];
                        member.sex = briAndSex[2];
                    } else {
                        Widget.popupToast(briAndSex[1]);
                        return;
                    }
                }
            } else {
                return;
            }
        }
        Util.data('cache.personalInfo',member);
        Util.data('personalInfo',info);
        Callback.pageBack();
    },
    validate: function(type, val) {
        if( val ) {
            if( type === 'mobileNo' && !(Validator.stringIsMobileNo(val)) ) { Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR); return false; }
            if( type === 'name' ) {
                if ( !(Validator.realName.test(val)) ) { Widget.popupToast('姓名处请输入2~5个中文字符'); return false; }
                if ( val.length > 5) { Widget.popupToast('姓名处请输入2~5个中文字符'); return false; }
            }
            if( type === 'paperNo' && val.length > 32 ) { 
                Widget.popupToast('证件号码长度不能超过32位'); 
                return false;
            }
            if ( type === 'address' && val.length > 80 ) { Widget.popupToast('地址长度不能超过80个字'); return false; }
            return true;
        } else {
            if( type === 'mobileNo' ) { Widget.popupToast(Views.errorMsg.NO_MOBILE);return false; }
            if( type === 'name' ) { Widget.popupToast('请输入真实姓名');return false; }
            if( type === 'paperNo' ){ Widget.popupToast('请输入证件号码');return false; }
            return true;
        }
    }
});
Callback.changeSexSel = function(btnId) {
	$('#sexMale').find('.sex-sel').removeClass('sel');
	$('#sexFemale').find('.sex-sel').removeClass('sel');
	$('#'+btnId).find('.sex-sel').addClass('sel');
};
Callback.submitMemberInfoOneVal = function() {
    Views.memberEditItemView.submit();
};

//------------------------- 选择成员 > memberSelectView
//
Views.memberSelectView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'memberSelectView',
		pageName: 'memberSelectView',
		name: '选择持卡人'
	},
	willShow: function(ct) {
		Util.data('memberSelectView.pageBack',true);

		var memberList = UserProfile.accounts, member = Util.data('cache.personalInfo');
		if( !member && memberList.length > 0) {
			member = UserProfile.accounts[0];
			Util.data('cache.personalInfo',member);
		}
		if( !member.id ) {
			member = Util.data('selected.personalInfo');
			Util.data('cache.personalInfo',member);
		}
		this.render(ct,{
			scrollerHeight: (memberList.length+1)/2*125,
			members: memberList,
			member: member
		});
		this.makeScrollable($('#memberListScroller'));

		// Util.data('selected.personalInfo', member);
	}
});
Callback.showMemberChoose = function(btnId) {
//	var member = UserProfile.findMember($('#'+btnId).attr('data-rel')-0);
    var member = Util.data('cache.personalInfo');
	Util.data('selected.personalInfo',member);
	StageManager.pushView(Views.memberSelectView);
};
Callback.memberSelect = function(btnId) {
	var _btn = $('#'+btnId), id = _btn.attr('data-rel')-0;
	if( !_btn.hasClass('sel') ) {
		var members = $('.member-item'), current = members.filter('.sel'), selected = UserProfile.findMember(id);
		current.removeClass('sel').addClass('un-sel').find('.member-icon').attr('src', './themes/images/member-list-5.png');
		_btn.removeClass('un-sel').addClass('sel').find('.member-icon').attr('src', './themes/images/member-list-3.png');

		Util.data('cache.personalInfo', selected);
		Util.data('selected.personalInfo', selected);
	}
	setTimeout(function(){
		Callback.pageBack();
	},180);
};

// ------------------------- 显示就诊卡信息页面 > medicalCardInfoView
//
Callback.showCardInfoView = function(btnId) {
    var id = $('#'+btnId).attr('data-rel'), card = UserProfile.findCardById(id), member;// = UserProfile.getCurrentMember();
    if( card ) {
        Util.data('cache.card', card);
        StageManager.pushView(Views.medicalCardEditView);
        return;
    } else {
        Widget.popupToast('就诊卡信息有误');
        return;
    }
    StageManager.pushView(Views.medicalCardEditView);
};

// ------------------------- 就诊卡管理 > medicalCardListView
//
Views.medicalCardListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medicalCardListView',
        name: '就诊卡管理'
    },
    willShow: function(ct) {
        var cards,type = Util.data('cardSelectType'), title = '就诊卡';

        if( APPVERSION === 'web' ) {
            cards = TestData.medicalCards;
        } else {
            cards = Util.data('cards') || [];
        }
        if(type === '住院号'){
            for(var i = 0; i < cards.length; i++){
                if(cards[i].medicalCardType !== '住院号'){
                    cards.splice(i, 1);
                    i=i-1;
                }
            }
            title = '住院号';
        }else{
            for(var i = 0; i < cards.length; i++){
                if(cards[i].medicalCardType === '住院号'){
                    cards.splice(i, 1);
                    i=i-1;
                }
            }
        }
        this.render(ct, {
            cards: cards || [],
            hospitalName: HOSPITAL_NAME,
            title: title
        });
    },
    didShow: function(ct){
        this.makeScrollable($('#card-select', ct));
        var cards = Util.data('cards') || [], needAddCard = true;

        if(cards || cards.length > 0){
            for(var i = 0; i < cards.length; i++){
                if (cards[i].medicalCardValid){
                    needAddCard = false;
                    break;
                }
            }
        }
        if(needAddCard){
            var type = Util.data('cardSelectType')|| '就诊卡';
            Util.confirm('您还未添加有效'+ type + '，是否去添加'+ type + '？',function(index) {
                if (index === 2) {
                    Callback.showAddmember('', type);
                }
            });
        }
    }
});
Callback.showMedicalCardListView = function(btnId){
    var type = $('#'+btnId).attr('data-rel');
    Util.data('cardSelectType', type);
    StageManager.pushView(Views.medicalCardListView);
};

Callback.showAddCard1 = function(btnId) {
    var card = {}, member = Util.data('cache.personalInfo');

    if( !member || !member.id) {
//        Util.alert('请先填写并保存持卡人信息！');
        Util.confirm('持卡人信息未保存，是否保存？', function(index){
            if(index === 2){
                Callback.addMemberSubmit();
            }
        });
        return;
    }
    if( member.id){
        var standardMember = UserProfile.findMember( member.id );
        if (standardMember ){
            var flag = true;
            if( member.name !== standardMember.name ) {
                flag = false;
            }else if(member.paperType !== standardMember.paperType){
                flag = false;
            }else if(member.paperNo !== standardMember.paperNo){
                flag = false;
            }else if(member.sex !== standardMember.sex){
                flag = false;
            }else if(member.birthday !== standardMember.birthday){
                flag = false;
            }
            else if(member.mobileNo !== standardMember.mobileNo){
                flag = false;
            }
            if(!flag){
                Util.confirm('持卡人信息未保存，是否保存？', function(index){
                    if(index === 2){
                        Callback.editMemberSubmit();
                    }
                });
                return;
            }
        }
    }

    var cardTypes = Util.data('cache.cardTypes');
    var rel = $('#'+btnId).attr('data-rel');
    if(rel && rel === '住院号'){
        for(var i = 0; i< cardTypes.length; i++){
            if(cardTypes[i].name === '住院号'){
                card.medicalCardTypeId = cardTypes[i].id;
                break;
            }
        }
        card.name = member.name;
        card.patientId = member.id;
        Util.data('cache.card',card);
        StageManager.pushView(Views.medicalCardAdd1View);
    }else{
        card.name = member.name;
        card.patientId = member.id;
        Util.data('cache.card',card);
        StageManager.pushView(Views.medicalCardAdd1View);
    }
};

Callback.showAddCard2 = function(btnId){
    var cardTypes = Util.data('cache.cardTypes');
    var rel = $('#'+btnId).attr('data-rel');
    var msg = '就诊卡号';

    if(rel && rel === '住院号'){
        msg = rel;
    }

    var member = Util.data('cache.personalInfo');
    if( !member.medicalCardNo ) {
        Widget.popupToast('请填写' + msg + '!');
        return;
    }
    if( !member.name ) {
        Widget.popupToast('请填写真实姓名!');
        return;
    }
    if( !Validator.stringIsRealName(member.name) ) {
        Widget.popupToast('姓名处请输入2~5个中文字符！');
        return;
    }
//    if( !member.paperType ) {
//        Widget.popupToast('请选择证件类型!');
//        return;
//    }
//    if( member.paperType !== '无身份证' && !member.paperNo ) {
//        Widget.popupToast('请填写证件号码!');
//        return;
//    }
//    if( member.paperType === '身份证' && !Validator.stringIsIdCard(member.paperNo)){
//        Widget.popupToast('您输入的身份证号码有误！');
//        return;
//    }
    if( member.idCard && !Validator.stringIsIdCard(member.idCard)){
        Widget.popupToast('您输入的身份证号码有误！');
        return;
    }
    var  mobileNo =  member.mobileNo ? member.mobileNo : member.mobile
    if( !mobileNo ) {
        Widget.popupToast('请填写手机号码!');
        return;
    }
    if( !member.verifyCode ) {
        Widget.popupToast('请输入验证码!');
        return;
    }
    if( !Validator.stringIsMobileNo(mobileNo) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }

    var data = $.extend({}, member);
    delete data.medicalCards;
//    data.isFamilyMember = true;
    data.accountId = UserProfile.id;
    data.paperType = CACHE.getPaperChangeValueAndKeyTypes()[data.paperType];


    if(rel && rel === '住院号'){
        for(var i = 0; i< cardTypes.length; i++){
            if(cardTypes[i].name === '住院号'){
                data.medicalCardTypeId = cardTypes[i].id;
                break;
            }
        }
    }

    Widget.popupLoading('正在提交数据...');
    var newData = {
        birthday: data.birthday,
        mobileNo: data.mobile,
        name: data.name,
        patientName : data.name,
        idCardNo: data.idCard,
//        paperType: data.paperType,
//        paperNo: data.paperNo,
        medicalCardNo: data.medicalCardNo,
        sex: data.sex,
//        address: '',
        accountId : UserProfile.id,
        medicalCardTypeId: data.medicalCardTypeId,
        verifyCode: data.verifyCode
    };
    FuckHttp.addCard({
        data: newData,
        success: function(json) {

            if(!json.success) {
                Util.alert(json.errMsg);
            } else {
                $('#deleteBtn').show();
                $('#saveBtn').hide();
//                UserProfile.refreshAccounts(json.data);
//                Util.data('members', json.data);

                var callFun = function(members){
                    for(var i = 0; i < members.length; i++) {
                        if(member.name === members[i].name && member.mobileNo === members[i].mobileNo){
                            member = members[i];
                        }
                    }
                    UserProfile.setCurrentMember(member);

                    member.id = json.data.patientId ;
                    Util.data('cache.personalInfo',member);
//                    Util.data('cache.card',member.medicalCards[0]);

                    CACHE.ajaxCards();

//                    var newCards = [member.medicalCards[0]];
//                    var cards = Util.data('cards') || [];
//                    Util.data('cards', newCards.concat(cards));

                    if(!member.id || member.id === 0){
                        $('.item.need-change').addClass('ui-btn');
                        $('.item.need-change .right-arrow').show();
                        $('.need-hide').show();
                    }else{
                        $('.item.need-change').removeClass('ui-btn');
                        $('.item.need-change .right-arrow').hide();
                        $('.need-hide').hide();
                    }
                    Widget.popupLoadingClose();
                    Widget.popupSuccess('添加成功！');
                };

                CACHE.ajaxMembers(callFun);

//                for(var i = 0; i < json.data.length; i++) {
//                    if(member.name === json.data[i].name && member.mobileNo === json.data[i].mobileNo){
//                        member = json.data[i];
//                    }
//                }
//                UserProfile.setCurrentMember(member);
//                Util.data('cache.personalInfo',member);
//                Util.data('cache.card',member.medicalCards[0]);
//                var newCards = [member.medicalCards[0]];
//                var cards = Util.data('cards') || [];
//                Util.data('cards', newCards.concat(cards));
//
//                if(!member.id || member.id === 0){
//                    $('.item.need-change').addClass('ui-btn');
//                    $('.item.need-change .right-arrow').show();
//                    $('.need-hide').show();
//                }else{
//                    $('.item.need-change').removeClass('ui-btn');
//                    $('.item.need-change .right-arrow').hide();
//                    $('.need-hide').hide();
//                }
//
//                Widget.popupSuccess('添加成功！');
            }
        },
        doneError: function(json) {
            Widget.popupLoadingClose();
            if(rel === '住院号'){
                json.errMsg = json.errMsg.replace('就诊卡', '住院号');
            }
            Util.alert(json.errMsg);
        }
    });
};
Views.medicalCardAdd1View = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'medicalCardAdd1View',
		name: '添加就诊卡'
	},
	willShow: function(ct) {
		var card = Util.data('cache.card'), member = Util.data('cache.personalInfo');
		if( Util.data('memberSelectView.pageBack') ) {
			card.patientName = member.name;
			card.patientId = member.id;

			Util.data('memberSelectView.pageBack','');
			Util.data('cache.card',card);
		}
		this.render(ct,{
			card: card,
            member: member
		});
        Util.inputs(ct.find('input'));
		this.makeScrollable($('.card-info-page'));
	},
    addCardSubmit: function() {
        if( APPVERSION === 'web' ) {
            Widget.popupLoading();
            setTimeout(function(){
                Widget.popupLoadingClose();
                Callback.pageBack();
            },1000);
        } else {
            var card = Util.data('cache.card'), _card = Util.data('cache.card');
            // delete card.patientName;
            card.accountId = UserProfile.id;
            var member = Util.data('cache.personalInfo');
            card.mobileNo = member.mobileNo;
            Widget.popupLoading();
            card.verifyCode = $('#secCode').val();


            delete card.patientId;
            card.patientName = card.name;

            FuckHttp.addCard({
                data: card,
                success: function(json) {
                    CACHE.addCardToCardCache(json.data);
                    Callback.pageBack();
                    Widget.popupSuccess(json.errMsg);
                },
                doneError: function(json) {
                    Util.data('cache.card', json.data);
                    Util.alert(json.errMsg);
                }
            });
        }
    },
    updateCard: function() {
        if( APPVERSION === 'web' ) {
            Widget.popupLoading();
            setTimeout(function(){
                Widget.popupLoadingClose();
                Callback.pageBack();
            },1000);
        } else {
            var card = Util.data('cache.card');
            // delete card.patientName;
            var member = Util.data('cache.personalInfo');
            card.mobileNo = member.mobileNo;
            card.verifyCode = $('#secCode').val();
            Widget.popupLoading();
            FuckHttp.updateCard({
                data: card,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if ( !json.success ) {
                        Util.confirm(json.errMsg, function(index) {
                            if (index === 1) {
                                Callback.pageBack();
                            } else {
                                Util.data('cache.card',$.extend({}, card, json.data));
                            }
                        });
                        return;
                    }
                    CACHE.addCardToCardCache(json.data);
                    Callback.pageBack();
                    Widget.popupSuccess(json.errMsg);
                }
            });
        }
    },
    getSecurityCode: function(btnId){
        var type = Util.data('cardSelectType');
        var member = Util.data('cache.personalInfo');
         var info = Util.data('personalInfo');
         var contactType =  Util.data('contactType');
         var mobileNo =   info.mobile ? info.mobile : info.mobileNo ;
        if(contactType == 'contact1') {
            if( !info.idCard ) {
                Widget.popupToast('请填写' );
                return;
            }
            if( !info.name ) {
                Widget.popupToast('请填写姓名！');
                return;
            }
            if( !info.mobile ) {
                Widget.popupToast('请填写手机号！');
                return;
            }
            var data= {
                accountId: member.accountId,
                patientName: info.name ,
                mobileNo: info.mobile,
                idCardNo :  info.idCard ,
                codeType: 4
            };

            FuckHttp.getCardScode({
                data: data,
                success: function(json){
                    Util.alert('发送成功');

                  Util.data('case.request.data', {verifyCodeNo: json.errMsg});
                    Callback.disableGetSCode(btnId);
                }
            });
        }else if(contactType == 'contact') {
            FuckHttp.contactType({
                data: {
                    mobileNo: mobileNo
                },
                success: function(json){
                    Util.alert('发送成功');
                    Callback.disableGetSCode(btnId);
                }
            });
        }else{
            if( !member.medicalCardNo ) {
                Widget.popupToast('请填写' + type + '！');
                return;
            }
            if( !member.name ) {
                Widget.popupToast('请填写姓名！');
                return;
            }
            if( !member.mobile ) {
                Widget.popupToast('请填写手机号！');
                return;
            }
            var data= {
                patientId: member.id,
                accountId: member.accountId,
                patientName: member.name,
                medicalCardNo: member.medicalCardNo,
                mobileNo: member.mobile,
                codeType: member.codeType
            };

            if(member.medicalCardTypeId){
                data.medicalCardTypeId = member.medicalCardTypeId;
            }
            FuckHttp.getCardScode({
                data: data,
                success: function(json){
                    Util.alert('发送成功');
                    Callback.disableGetSCode(btnId);
                }
            });

        }

    }
});
Callback.getAddCardSCode = function(btnId) {

    Views.medicalCardAdd1View.getSecurityCode(btnId);
};
Callback.editCardInfo = function(btnId) {
    var card = Util.data('cache.card');
    var _btn = $('#'+btnId),
        item = _btn.attr('data-rel'),
        title = _btn.find('.label').html(),
        val = _btn.find('.value').html(), hint;

    switch( item ){
        case 'card-number':
            hint = '请输入'+title;
            val = card.medicalCardNo;
            break;
        case 'card-name':
            hint = '请输入真实姓名';
            break;
        case 'card-type':
            hint = '选择就诊卡类型';
            break;
    }

    Util.data('medicalCardInfoInputEditView.show.data',{
        item: item,
        title: title,
        val: val,
        hint: hint
    });
    StageManager.pushView(Views.medicalCardInfoInputEditView);
};
Callback.changePaperType  = function(btnId) {
    $('.sex-sel').removeClass('sel');
    $('#'+ btnId+ ' .sex-sel').addClass('sel');
};
Callback.addCardSubmit = function() {
    var card = Util.data('cache.card');
    if( !card.medicalCardNo && !card.medicalCardTypeId ) {
        Widget.popupToast('请填写就诊卡！');
        return;
    }
    if( !card.medicalCardNo && card.medicalCardTypeId ) {
        Widget.popupToast('请填写住院号！');
        return;
    }
    if(!$('#secCode').val()){
        Widget.popupToast('请输入验证码！');
        return;
    }
    if( card.id > 0 ) {
        Views.medicalCardAdd1View.updateCard();
    } else {
        Views.medicalCardAdd1View.addCardSubmit();
    }
};

Views.medicalCardEditView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'medicalCardEditView',
		name: '编辑就诊卡'
	},
	willShow: function(ct) {
		var card = Util.data('cache.card'), member = Util.data('cache.personalInfo');
		if( Util.data('memberSelectView.pageBack') ) {
			card.patientName = member.name;
			card.patientId = member.id;

			Util.data('cache.card',card);
			Util.data('memberSelectView.pageBack','');
		}
		this.render(ct,{
			card: card
		});
		this.makeScrollable($('.card-info-page'));
	},
    deleteCard: function() {
        var data = Util.data('cache.card'), self = this;
        Util.confirm('您确定要删除吗？', function(index) {
            if (index === 2 ) {
                Widget.popupLoading("正在删除...");
                if (APPVERSION === 'web') {
                    Widget.popupLoadingClose();
                    Callback.pageBack();
                    Widget.popupSuccess('删除成功！');
                } else {
                    FuckHttp.deleteCard({
                        cardId: data.id,
                        success: function(json) {
                            Widget.popupLoadingClose();
                            if ( !json.success ) {
                                Util.alert(json.errMsg);
                                return;
                            }
                            self.deleteCardFromData(data.id);
                            Callback.pageBack();
                            Widget.popupSuccess('删除成功！');
                        }
                    });
                }
            }
        });
    },
    deleteCardFromData: function(id) {
        var cards = Util.data('cards');
        for (var i = 0; i < cards.length; i++) {
            if ( id-0 === cards[i].id-0 ) {
                cards.splice(i,1);
                break;
            }
        }
        Util.data('cards',cards);
    }
});
Callback.deleteCard = function() {
    Views.medicalCardEditView.deleteCard();
};

// ------------------------- 编辑就诊卡详细信息 > medicalCardInfoInputEditView
Views.medicalCardInfoInputEditView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medicalCardInfoInputEditView',
        pageName: 'medicalCardInfoInputEditView',
        name: '编辑就诊卡'
    },
    willShow: function(ct) {
        var show_data = Util.data('medicalCardInfoInputEditView.show.data'),
            card = Util.data('cache.card'),
            cardTypes = Util.data('cache.cardTypes');

        if(show_data.item === 'card-type') {
            if( cardTypes ) {
                this.render(ct,{
                    showData: show_data,
                    card: card,
                    cardTypes: cardTypes
                });
                Util.inputs($('input'));
            } else {
                var self = this;
                initUnLoginData(function(){
                    self.render(ct,{
                        showData: show_data,
                        card: card
                    });
                    Util.inputs($('input'));
                });
            }
        } else {
            this.render(ct,{
                showData: show_data,
                card: card,
                cardTypes: []
            });
            Util.inputs($('input'));
        }
    },
    saveCardOneVal: function() {
        var show_data = Util.data('medicalCardInfoInputEditView.show.data'),
            card = Util.data('cache.card');
        if( show_data.item === 'card-number' ) {
            var val = $('#card-number').val();
            if( !val ) {
                Widget.popupToast(show_data.hint);
                return;
            }
            /*if( isNaN(val) ) {
             Widget.popupToast('请输入正确的卡号');
             return;
             }*/
            card.medicalCardNo = val;
        } else if( show_data.item === 'card-name' ) {
            var name = $('#card-name').val();
            if( !name || !$.trim(name) ) {
                Widget.popupToast('请输入真实姓名');
                return;
            }
            if (name.length > 8) {
                Widget.popupToast('名字最长8位，请修改！');
                return;
            }
            card.name = name;
        } else if( show_data.item === 'card-type' ) {
            if( $('.card-type').find('.sel').length > 0 ) {
                var type = $('.card-type').find('.sel').parent(), cardId = type.attr('data-rel'),
                    cardName = type.find('.sex-label').html();
                card.medicalCardType = cardName;
                card.medicalCardTypeId = cardId;
            } else {
                Widget.popupToast('请选择卡类型');
                return;
            }
        }
        Util.data('cache.card',card);
        Callback.pageBack();
    }
});
Callback.saveCardOneVal = function() {
    Views.medicalCardInfoInputEditView.saveCardOneVal();
};
Callback.selectCardType = function(btnId){
    $('.sex-sel').removeClass('sel');
    $('#'+ btnId+ ' .sex-sel').addClass('sel');
//    var card = Util.data('cache.card');
//    card.medicalCardTypeId = $('#'+btnId).attr('data-rel'),
//    card.medicalCardType = $('#'+btnId).attr('data-name');
//    Util.data('cache.card', card);
//    Callback.pageBack()
};

// ------------------------- 就诊卡选择 > medicalCardSelectView
//
Callback.showCardSelectView = function(btnId){
    var type = $('#'+btnId).attr('data-rel');

    if(type === '住院号'){
        Util.data('cardSelectType', type);
        if(UserProfile.findTrueCards('住院号').length === 0){
            Util.confirm('您还没有添加住院号，是否添加住院号？', function(index) {
                if (index === 2) {
                    Util.data('cardSelectType', '住院号');
                    Callback.showAddmember('', '住院号');
                }
            });
            return;
        }
    }else{
        Util.data('cardSelectType', '就诊卡');
        if(UserProfile.findTrueCards().length === 0){
            Util.confirm('您还没有添加就诊卡，是否添加就诊卡？', function(index) {
                if (index === 2) {
                    Util.data('cardSelectType', '就诊卡');
                    Callback.showAddmember('', '就诊卡');
                }
            });
            return;
        }
    }
    StageManager.pushView(Views.medicalCardSelectView);
};
Views.medicalCardSelectView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'medicalCardSelectView',
        name: '就诊卡选择'
    },
    willShow: function(ct) {
        var cards, selected,type = Util.data('cardSelectType'), title = '就诊卡';

        selected = Util.data('cache.card');
        if(!selected) {
            selected = {id:0};
            Util.data('cache.card','');
        }

        if( APPVERSION === 'web' ) {
            cards = TestData.medicalCards;
        } else {
            cards = Util.data('cards');
        }
        if(type === '住院号'){
            for(var i = 0; i < cards.length; i++){
                if(cards[i].medicalCardType !== '住院号'){
                    cards.splice(i, 1);
                    i=i-1;
                }
            }
            title = '住院号';
        }else{
            for(var i = 0; i < cards.length; i++){
                if(cards[i].medicalCardType === '住院号'){
                    cards.splice(i, 1);
                    i=i-1;
                }
            }
            title = '就诊卡';
        }
        this.render(ct, {
            cards: cards || [],
            selected: selected,
            hospitalName: HOSPITAL_NAME,
            title: title
        });
    },
    didShow: function(ct){
        this.makeScrollable($('#card-select', ct));
        var cards = Util.data('cards'), needAddCard = true;

        if(cards || cards.length > 0){
            for(var i = 0; i < cards.length; i++){
                if (cards[i].medicalCardValid){
                    needAddCard = false;
                    break;
                }
            }
        }
        if(needAddCard){
            var type = Util.data('cardSelectType')|| '就诊卡';
            Util.confirm('您还未添加有效'+ type + '，是否去添加'+ type + '？',function(index) {
                if (index === 2) {
                    StageManager.pushView(Views.memberListView);
                }
            });
        }
    }
});
Callback.chooseCard = function(btnId) {
    $('.card-item').addClass('un-sel');
    var cardId = $('#'+btnId).removeClass('un-sel').attr('data-rel'),
        card = UserProfile.findCardById(cardId-0),
        member = UserProfile.findMember(card.patientId);
    Util.data('cache.card',card);
    Util.data('cache.personalInfo',member);

    setTimeout(function(){
        Callback.pageBack();
    },300);
};

//---------------------重置手机账号 resetAccountView
Views.reSetAcountView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'reSetAcountView',
        pageName: 'reSetAcountView',
        name: '重置账号'
    },
    willShow: function(ct) {
        this.render(ct,{
            code: UserProfile.code
        });
        Util.inputs($('#resetAccount input'));
        if( Util.data('reGetSC.interval') || Util.data('reGetSC.time') ) {
            $('#scBtn').removeClass('ui-btn').addClass('gray').html(Util.data('reGetSC.time')+'秒');
        }
    },
    getSecurityCode: function(params, btnId) {
        if (APPVERSION === 'web') {
            Util.alert('获取验证码成功！');
            Callback.disableGetSCode(btnId);
        } else {
            FuckHttp.getResetAccountSecCode({
                mobileNo: params.mobileNo,
                success: function(json) {
                    Util.alert(json.errMsg);
                    Callback.disableGetSCode(btnId);
                }
            });
        }
    },
    resetAccountAjax: function(param) {
        if (APPVERSION === 'web') {
            TestSuit.changeAccount(param);
        } else {
            param.deviceId = DEVICE_UUID;
            param.version = VERSION_NUMBER;

            FuckHttp.resetAccountAjax({
                data: param,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    Views.reSetAcountView.refreshAccount(param);
                    Util.alert('修改成功', function() {Callback.pageBack();});
                }
            });
        }
    },
    refreshAccount: function(param) {
        UserProfile.code = param.mobileNo;
        var userParam =  Util.data('profile.user'),
            remindPassword = Util.data('remindPassword');
        if (userParam) {
            Util.data('profile.user', {
                id: userParam.id,
                code:param.mobileNo,
                accounts: userParam.accounts
            });
        }
        if (remindPassword) {
            UserProfile.setUserRemindPassword({code:param.mobileNo,password:param.password});
        }
    }
});
Callback.getResetSecCode = function(btnId) {
    var mobileNo = $('#mobile').val();
    if ( !mobileNo ) {
        Widget.popupToast(Views.errorMsg.NO_MOBILE);
        return;
    }
    if ( Validator.stringContainsSpace(mobileNo) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobileNo) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    Views.reSetAcountView.getSecurityCode({mobileNo:mobileNo}, btnId);
};
Callback.resetAccount = function() {
    var oldPassword = $('#oldPassword').val(),
        mobile = $('#mobile').val(),
        password = $('#password').val(),
        rePassword = $('#rePassword').val(),
        securityCode = $('#securityCode').val(),
        oldAccount = UserProfile.code;

    if ( !oldPassword ) {
        Widget.popupToast(Views.errorMsg.NO_OLD_PASSWORD);
        return;
    }

    if ( !mobile ) {
        Widget.popupToast(Views.errorMsg.NO_NEW_MOBILE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobile) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    if ( !password ) {
        Widget.popupToast(Views.errorMsg.NO_NEW_PASSWORD);
        return;
    }
    if ( !rePassword ) {
        Widget.popupToast(Views.errorMsg.NO_RE_PASSWORD);
        return;
    }
    if ( password !== rePassword ) {
        Widget.popupToast(Views.errorMsg.PASSWORD_NOT_EQUALS_REPASSWORD);
        return;
    }
    if (!Validator.stringIsNumOrEn(password)) {
        Widget.popupToast('请输入6~16位英文或数字密码');
        return;
    }
    if ( !securityCode ) {
        Widget.popupToast(Views.errorMsg.NO_SECURITY_CODE);
        return;
    }

    if ( Validator.stringContainsSpace(mobile) || Validator.stringContainsSpace(password) || Validator.stringContainsSpace(securityCode) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }

    Views.reSetAcountView.resetAccountAjax({
        oldAccount: oldAccount,
        oldPassword: oldPassword,
        mobileNo: mobile,
        password: password,
        verifyCode: securityCode,
        hospitalId: HOSPITAL_ID
    });
};
// ------------------------- 修改密码 > changePwdView
//
Views.changePwdView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'changePwdView',
        name: '修改密码',
        pageName: 'changePwdView'
    },
    willShow: function(ct) {
        this.render(ct,{
            code: UserProfile.code
        });
        Util.inputs($('#changePassword input'));
    },
    changePassword: function(params) {
        if (APPVERSION === 'web') {
            TestSuit.changePassword(params);
        } else {
            params.deviceId = DEVICE_UUID;
            params.version = VERSION_NUMBER;
            Widget.popupLoading('重置中，请稍候...');
            FuckHttp.changePassword({
                data: params,
                success: function(json){
                    Widget.popupLoadingClose();
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    if ( StageManager.getCurrentPageName() === 'changePwdView' ) {
                        $.extend(UserProfile, json.data);
                        if ( UserProfile.isRemindPwd() ) {
                            var obj =  Util.data('remindPassword');
                            obj.passwrod = params.newPassword;
                            UserProfile.setUserRemindPassword(obj);
                        }
                        Util.alert(json.errMsg, function() {
                            Callback.pageBack();
                        });
                    }
                }
            });
        }
    }
});
Callback.changePassword = function () {
    var oldPwd = $('#oldPassword').val();
    var newPwd = $('#newPassword').val();
    var rePwd = $('#rePassword').val();

    if ( !oldPwd) {
        Widget.popupToast(Views.errorMsg.NO_OLD_PASSWORD);
        return;
    }
    if ( !newPwd ) {
        Widget.popupToast(Views.errorMsg.NO_NEW_PASSWORD);
        return;
    }
    if ( !rePwd ) {
        Widget.popupToast(Views.errorMsg.NO_RE_PASSWORD);
        return;
    }
    if ( newPwd !== rePwd ) {
        Widget.popupToast(Views.errorMsg.PASSWORD_NOT_EQUALS_REPASSWORD);
        return;
    }

    if ( Validator.stringContainsSpace(oldPwd) || Validator.stringContainsSpace(rePwd)){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    if (!Validator.stringIsNumOrEn(newPwd)) {
        Widget.popupToast('请输入6~16位英文或数字密码');
        return;
    }
    Views.changePwdView.changePassword({
        accountId:UserProfile.id,
        oldPassword:oldPwd,
        newPassword:newPwd,
        confirmPassword:rePwd,
        hospitalId: HOSPITAL_ID
    });
};
// ------------------------- 登录 > loginView
//
Views.loginView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'loginView',
        name: '登录',
        pageName: 'loginView'
    },
    willShow: function(ct) {
        var code = "",
            password = "";
        if (UserProfile.isRemindPwd()) {
            var userObj = Util.data('remindPassword');
            code = userObj.code;
            password = userObj.password;
        }
        this.render(ct, {
            code:code,
            password:password,
            remindPwd: UserProfile.isRemindPwd()?'sel':'',
            autoLogin: UserProfile.isAutoLogin()?'sel':''
        });
//        Util.inputs($('#doLogin input'));
        Util.inputs($('input'));
    },
    loginAjax: function(params) {
            FuckHttp.checkVersion({
                success: function(json) {
                    var version = json.data.versionID,
                        hasNewVersion = false,
                        v1 = version.split('.'), v2 = VERSION_NUMBER.split('.');
                    for (var i = 0; i < 3; ++i) {
                        if (v1[i]-0 > v2[i]-0) {
                            LAST_VERSION_NUMBER = version;
                            hasNewVersion = true;
                            break;
                        }
                    }
                    if (hasNewVersion) {
                        //更新页面和设置缓存
                        Util.data('hasNewVersion', true);

                        if( json.data.mustUpgrade === 'NO' ) {
                            /*Util.confirm('发现新版本' + version + '，是否要立即更新？', function(index) {
                                if (index === 2) {
                                    window.open(json.data.versionUrl, '_system');
                                } else {
                                    Util.data('version.deferUpdate', new Date() - 0);
                                }
                            }, null, '暂不更新,更新');*/
                        } else {
                            Util.alert('有新版本' + LAST_VERSION_NUMBER + '，需要更新', function() {
                                window.open(json.data.versionUrl, '_system');
                            }, null, '确定');
                            return;
                        }
                    }
                    FuckHttp.login({
                        data: params,
                        success: function(json) {
                            Util.data('cache.accountInfo', json.data);
                           var  member =  Util.data('cache.Info');
                            member = {
                                accountId : json.data.id

                            }
                            Util.data('cache.Info',member) ;

                            $.extend(UserProfile, json.data);
                            UserProfile.saveCache();
                            UserProfile.setUserLoggedIn();
                            var autoLogin = params.autoLogin;
                            var remindPassword = params.remindPassword;
                            if ( autoLogin ) {
                                UserProfile.setUserAutoLogin();
                                UserProfile.setUserRemindPassword({code:params.mobileNo,password:params.password});
                            } else {
                                UserProfile.clearUserAutoLogin();
                                if ( remindPassword ) {
                                    UserProfile.setUserRemindPassword({code:params.mobileNo,password:params.password});
                                } else {
                                    UserProfile.clearUserRemindPassword();
                                }
                            }
                            initAccount();
                            Callback.pageBack();
                            Widget.popupSuccess('登录成功！');
                            FuckHttp.getIM({
                                data: {
                                    accountId: UserProfile.id,
                                    systemToken: 'ZSYY'
                                },
                                success: function(json) {
                                    Util.data('IM', json.data);
                                    var data = Util.data('cache.accountInfo');
                                    data.imPassword = json.data.password;
                                    data.imUserName = json.data.userName;
                                    Util.data('cache.accountInfo', data);
                                    Callback.showLogin();
                                },
                                doneError: function(json) {
                                    FuckHttp.regIM({
                                        data: {
                                            accountId: UserProfile.id,
                                            systemToken: 'ZSYY',
                                            mobile: UserProfile.code,
                                            password: params.password
                                        },
                                        success: function(json) {
                                            Util.data('IM', json.data);
                                            var data = Util.data('cache.accountInfo');
                                            data.imPassword = json.data.password;
                                            data.imUserName = json.data.userName;
                                            Util.data('cache.accountInfo', data);
                                            Callback.showLogin();
                                        },
                                        doneError: function(json) {

                                        }
                                    });
                                }
                            });
                        },
                        doneError: function(json) {
                            Util.alert(json.errMsg);
                            if ( '手机号或密码错误，请重试' === json.errMsg ) {
                                $('#password').val('');
                            }
                        }
                    });
                },
                doneError: function(json) {
                    FuckHttp.login({
                        data: params,
                        success: function(json) {
                            $.extend(UserProfile, json.data);
                            UserProfile.saveCache();
                            UserProfile.setUserLoggedIn();
                            var autoLogin = params.autoLogin;
                            var remindPassword = params.remindPassword;
                            if ( autoLogin ) {
                                UserProfile.setUserAutoLogin();
                                UserProfile.setUserRemindPassword({code:params.mobileNo,password:params.password});
                            } else {
                                UserProfile.clearUserAutoLogin();
                                if ( remindPassword ) {
                                    UserProfile.setUserRemindPassword({code:params.mobileNo,password:params.password});
                                } else {
                                    UserProfile.clearUserRemindPassword();
                                }
                            }
                            initAccount();
                            Callback.pageBack();
                            Widget.popupSuccess('登录成功！');
                        },
                        doneError: function(json) {
                            Util.alert(json.errMsg);
                            if ( '手机号或密码错误，请重试' === json.errMsg ) {
                                $('#password').val('');
                            }
                        }
                    });
                }
            });
    }
});
Callback.pwdAndAuto =function(btnId) {
    var _btn = $('#'+btnId).removeClass('active').toggleClass('sel');
    if( _btn.attr('data-rel') === 'pwd' && !_btn.hasClass('sel') ) {
        $('#option-auto').removeClass('sel');
        return;
    }
    if( _btn.attr('data-rel') === 'auto' && _btn.hasClass('sel') ) {
        $('#option-pwd').addClass('sel');
        return;
    }
};
Callback.doLogin = function(btnId) {
    if( APPVERSION === 'android'){
        cordova.exec(
            function (args) {

            },
            function (args) {

            },
            "SoftKeyBoard",
            "hide",
            []
        );
    }
    var code = $('#code').val();
    var password = $('#password').val();

    if( !code || !password ) {
        Widget.popupToast(Views.errorMsg.COMPLETE_CODE_AND_PASSWORD);
        return;
    }

    if ( Validator.stringContainsSpace(code) || Validator.stringContainsSpace(password) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    Widget.popupLoading('正在登录...');
    var autoLogin = false;
    var remindPassword = false;
    if( $('#option-pwd').hasClass('sel') ) {
        remindPassword = true;
    }
    if ( $('#option-auto').hasClass('sel') ) {
        autoLogin = true;
    }
    Views.loginView.loginAjax({
        mobileNo: code,
        password: password,
        autoLogin: autoLogin,
        remindPassword: remindPassword
    });
};
Callback.doLogout = function(btnId) {
    Util.confirm('您确定要退出当前的登录账号吗？', function(index) {
        if (index === 2) {
            UserProfile.setUserLogout();
            Callback.showLogout();
            Callback.switchMainTabView('main-footer-1');
            Widget.popupSuccess('您已成功退出登录！');
        }
    });
};

// ------------------------- 忘记密码 > forgotPwdView
//
Views.forgotPwdView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'forgotPwdView',
        name: '忘记密码',
        pageName: 'forgotPwdView'
    },
    willShow: function(ct) {
        this.render(ct);
        Util.inputs($('.forgotPwd-form input'));
        if( Util.data('reGetSC.interval') || Util.data('reGetSC.time') ) {
            $('#scBtn').removeClass('ui-btn').addClass('gray').html(Util.data('reGetSC.time')+'秒');
        }
    },
    getSecurityCode: function(params, btnId) {
        if (APPVERSION === 'web') {
            Util.alert('获取验证码成功！');
            Callback.disableGetSCode(btnId);
        } else {
            Widget.popupLoading('正在获取验证码');
            FuckHttp.getPwdCode({
                mobileNo: params.mobileNo,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    Util.alert(json.errMsg);
                    Callback.disableGetSCode(btnId);
                }
            });
        }
    },
    resetPwdAjax: function(params) {
        if (APPVERSION === 'web') {
            TestSuit.forgetChangePwdAjax(params);
        } else {
            params.deviceId = DEVICE_UUID;
            params.version = VERSION_NUMBER;
            Widget.popupLoading('重置中，请稍候...');
            FuckHttp.goForgotPwd({
                data: params,
                success: function (json) {
                    Widget.popupLoadingClose();
                    if( StageManager.getCurrentPageName() !== 'forgotPwdView' ) return;
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    $.extend(UserProfile, json.data);
                    UserProfile.setUserLoggedIn();
                    Util.alert(json.errMsg, function() {
                        StageManager.pushView(Views.mainView);
                    });
                }
            });
        }
    }
});
Callback.getPwdSecurityCode = function(btnId) {
    var mobileNo = $('#mobileNo').val();
    if ( !mobileNo ) {
        Widget.popupToast(Views.errorMsg.NO_MOBILE);
        return;
    }
    if ( Validator.stringContainsSpace(mobileNo) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobileNo) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    Views.forgotPwdView.getSecurityCode({mobileNo:mobileNo}, btnId);
};
Callback.doResetPwd = function() {
    var mobile = $('#mobileNo').val();
    var password = $('#password').val();
    var rePassword = $('#rePassword').val();
    var securityCode = $('#secCode').val();
    if ( !mobile ) {
        Widget.popupToast(Views.errorMsg.NO_MOBILE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobile) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    if ( !password ) {
        Widget.popupToast(Views.errorMsg.NO_PASSWORD);
        return;
    }
    if ( !rePassword ) {
        Widget.popupToast(Views.errorMsg.NO_RE_PASSWORD);
        return;
    }
    if ( password !== rePassword ) {
        Widget.popupToast(Views.errorMsg.PASSWORD_NOT_EQUALS_REPASSWORD);
        return;
    }
    if (!Validator.stringIsNumOrEn(password)) {
        Widget.popupToast('请输入6~16位英文或数字密码');
        return;
    }
    if ( !securityCode ) {
        Widget.popupToast(Views.errorMsg.NO_SECURITY_CODE);
        return;
    }

    if ( Validator.stringContainsSpace(mobile) || Validator.stringContainsSpace(password) || Validator.stringContainsSpace(securityCode) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }

    Views.forgotPwdView.resetPwdAjax({
        mobileNo: mobile,
        newPassword: password,
        confirmPassword: rePassword,
        verifyCode: securityCode,
        hospitalId: HOSPITAL_ID
    });
};

// ------------------------- 注册 > registerView
//
Views.regProtocolView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'regProtocolView',
        name: '注册协议'
    },
    willShow: function(ct) {
        this.render(ct, {
            content: Util.data('regProtocol')?Util.data('regProtocol'):''
        });
        this.makeScrollable($('#notes-registration'));
        var self = this;
        Widget.popupLoading('正在加载注册协议');
        var aboutUsStr = Util.data('regProtocol'), updateTime = Util.data('regProtocol.update'),data = {};
        data.type = 'USER_REG_PROTOCOL';
        if(updateTime){
            data.updateTime = updateTime;
        }
        data.hospitalId = HOSPITAL_ID;
        FuckHttp.loadHospitalNote({
            data: data,
            success: function(json) {
                Widget.popupLoadingClose();
                var updateTime = json.data? json.data.updateTime : '',
                    content = json.data? json.data.content : Util.data('regProtocol');
                Util.data('regProtocol.update',updateTime);
                Util.data('regProtocol',content);
                self.render(ct,{
                    content: content
                });
                self.makeScrollable($('#notes-registration'));
            }
        });
    }
});
Views.registerView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'registerView',
        name: '注册',
        pageName: 'registerView'
    },
    willShow: function(ct) {
        this.render(ct);
        Util.inputs($('#doRegister input'));
        if( Util.data('reGetSC.interval') || Util.data('reGetSC.time') ) {
            $('#scBtn').removeClass('ui-btn').addClass('gray').html(Util.data('reGetSC.time')+'秒');
        }
//        StageManager.fixViewStack([Views.mainView,Views.registerView]);
    },
    getSecurityCode: function(params, btnId) {
        if (APPVERSION === 'web') {
            Util.alert('获取验证码成功！');
            Callback.disableGetSCode(btnId);
        } else {
            Widget.popupLoading('正在获取注册验证码');
            FuckHttp.getRegisterCode({
                mobileNo: params.mobileNo,
                success: function(json) {
                    Widget.popupLoadingClose();
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    Util.alert(json.errMsg);
                    Callback.disableGetSCode(btnId);
                }
            });

        }
    },
    registerAjax: function(params) {
        if (APPVERSION === 'web') {
            TestSuit.doRegister(params);
        } else {
            params.deviceId = DEVICE_UUID;
            params.version = VERSION_NUMBER;
            Widget.popupLoading('注册中，请稍候...');
            FuckHttp.goRegister({
                data: params,
                success: function (json) {
                    Widget.popupLoadingClose();
                    if( StageManager.getCurrentPageName() !== 'registerView' ) return;
                    if (!json.success) {
                        Util.alert(json.errMsg);
                        return;
                    }
                    $.extend(UserProfile, json.data);
                    UserProfile.setUserLoggedIn();
                    if (Util.data('profile.user')) {
                        UserProfile.setUserAutoLogin();  // set back to data-store
                    }
                    StageManager.pushView(Views.registerSuccessView);
                }
            });
        }
    }
});
Callback.getRegSecurityCode = function(btnId) {
    var mobileNo = $('#mobileNo').val();
    if ( !mobileNo ) {
        Widget.popupToast(Views.errorMsg.NO_MOBILE);
        return;
    }
    if ( Validator.stringContainsSpace(mobileNo) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobileNo) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    Views.registerView.getSecurityCode({mobileNo:mobileNo}, btnId);
};
Callback.doRegister = function(btnId) {
    var mobile = $('#mobileNo').val();
    var password = $('#password').val(), rePassword = $('#rePassword').val(); //= password;
    var securityCode = $('#secCode').val();
    if ( !mobile ) {
        Widget.popupToast(Views.errorMsg.NO_MOBILE);
        return;
    }
    if ( !Validator.stringIsMobileNo(mobile) ) {
        Widget.popupToast(Views.errorMsg.MOBILE_FORMAT_ERROR);
        return;
    }
    if ( !password) {
        Widget.popupToast(Views.errorMsg.NO_PASSWORD);
        return;
    }
    if ( !rePassword ) {
        Widget.popupToast(Views.errorMsg.NO_RE_PASSWORD);
        return;
    }
    if (!Validator.stringIsNumOrEn(password)) {
        Widget.popupToast('请输入6~16位英文或数字密码');
        return;
    }
    if ( !securityCode ) {
        Widget.popupToast(Views.errorMsg.NO_SECURITY_CODE);
        return;
    }
    if ( Validator.stringContainsSpace(mobile) || Validator.stringContainsSpace(password) || Validator.stringContainsSpace(securityCode) ){
        Widget.popupToast(Views.errorMsg.CONTENT_NOT_HAS_SPACE);
        return;
    }
    if ( password !== rePassword ) {
        Widget.popupToast(Views.errorMsg.PASSWORD_NOT_EQUALS_REPASSWORD);
        return;
    }
    Views.registerView.registerAjax({
        mobileNo: mobile,
        password: password,
        confirmPassword: rePassword,
        verifyCode: securityCode,
        hospitalId: HOSPITAL_ID
    });
};

// ------------------------- 注册成功 > registerSuccessView
//
Views.registerSuccessView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'registerSuccessView',
        name: '注册成功'
    },
    willShow: function(ct) {
        this.render(ct);
    }
});

// ------------------------- 完善信息 > improvePerInfoView
//
Callback.showImprovePer = function(btnId){
//    var member = {sex: "MALE", paperType: "身份证"};
//    var cardTypes = Util.data('cache.cardTypes');
//    var rel = $('#'+btnId).attr('data-rel');
//    if(rel && rel === '住院号'){
//        for(var i = 0; i< cardTypes.length; i++){
//            if(cardTypes[i].name === '住院号'){
//                member.medicalCardTypeId = cardTypes[i].id;
//                break;
//            }
//        }
//    }
//    Util.data('cardSelectType', $('#'+btnId).attr('data-rel'));
//    Util.data('cache.personalInfo', member);
//    StageManager.pushView(Views.memberAddView);
};

Callback.backToCenterView = function(){
    Util.data('index.mainView', 3);
//    StageManager.pushView(Views.mainView);
    Callback.pageBackToView('mainView');
};

// -------------------------- 初始化证件类型
function initPaperType() {
    var data = [
        {
            "key": "IDENTITY_CARD",
            "name": "身份证"
        },
        {
            "key": "OFFICER_IDENTITY_CARD",
            "name": "军官证"
        },
        {
            "key": "PASSPORT",
            "name": "护照"
        },
        {
            "key": "BIRTH_APPROVAL_CERTIFICATE",
            "name": "准生证"
        },

    ];
    if (APPVERSION === 'web') {
        Util.data('paperType', data);
        changePaperKeyAndValue(Util.data('paperType'));
        return;
    }
    var lastTime = Util.data('paperTypes.times'),
        now = new Date() - 0;
    if (APPVERSION !== 'product' || !lastTime || now - lastTime > Util.MILLIS_1_DAY) {
        Util.data('paperTypes', Util.data('paperTypes') || data);
        changePaperKeyAndValue(Util.data('paperTypes'));
        FuckHttp.getPaperType({
            data: HOSPITAL_ID,
            success: function(json) {
                data = json.data || data;
                Util.data('paperTypes', data);
                Util.data('paperTypes.times', new Date() - 0);
                changePaperKeyAndValue(Util.data('paperTypes'));
            }
        });
    }
}

function changePaperKeyAndValue(data) {
    var dict = {};
    for (var i = 0; i < data.length; i++) {
        dict[data[i].name] = data[i].key;
        dict[data[i].key] = data[i].key;
    }
    Util.data('paperChangeType', dict);
}

// -------------------------------- 60秒内无法重新获取验证码
Callback.disableGetSCode  = function(btnId) {
    if( Util.data('reGetSC.interval' + btnId) || Util.data('reGetSC.timel' + btnId) ) {
        clearInterval(Util.data('reGetSC.intrval'));
        Util.data('reGetSC.interval' + btnId,'');
        Util.data('reGetSC.timel' + btnId,'');
    }
    var scBtn = $('#'+ btnId), date = new Date(), time;
    time = date.getTime();
    scBtn.removeClass('ui-btn').removeClass('btn-bg-securityCode').addClass('gray');
    scBtn.html('60秒');

    Util.data('reGetSC.timel' + btnId, time);
    Util.data(
            'reGetSC.interval' + btnId,
        setInterval(function(){
            var sc = $('#'+ btnId),
                nowTime = (new Date()).getTime(),
                oldTime = Util.data('reGetSC.timel' + btnId),
                seconds;
            seconds =Math.ceil(( nowTime-oldTime)/1000);
            if( sc.length === 0){
                clearInterval(Util.data('reGetSC.interval' + btnId));
                return;
            }
            seconds = 60 - seconds;
            if( seconds === 0 || seconds < 0) {
                clearInterval(Util.data('reGetSC.interval' + btnId));
                sc.removeClass('gray').addClass('ui-btn').addClass('btn-bg-securityCode');
                sc.html('获取验证码');
                Util.data('reGetSC.interval' + btnId,'');
                Util.data('reGetSC.timel' + btnId,'');
                return;
            }
            sc.removeClass('ui-btn').removeClass('btn-bg-securityCode').addClass('gray');
            sc.html(seconds+'秒');
        },1000)
    );
};

//---------------------消息中心
//
Callback.showMsgCenterView = function(btnId){
    var view = Views.MsgCenterView;
    view.options.pageIndex = 1;
    FuckHttp.getMsgType({
        success: function(json) {
            for(var i = 0; i < json.data.length; i++){
                if(json.data[i].chineseStr == '系统通知'){
                    json.data.splice(i, 1);
                    break;
                }
            }
            var newArray = [];
            newArray.push(json.data[1]);
            newArray.push(json.data[0]);
            Util.data('cache.msgTypes', newArray);
            Util.data('cache.msgType', newArray[0].type);
            Widget.popupLoadingClose();

            var self = view;
            var  hospital = Util.data('hosptial') ? Util.data('hosptial') : 'GRINM'  , hospitalId;
            if(hospital == 'GRINM'){
                hospitalId = HOSPITAL_ID ;
            }else{
                hospitalId = BRANCH_HOSPITAL_ID ;
            }
            FuckHttp.getMsgByType({
                data: {
                    hospitalId: HOSPITAL_ID,
                    accountId: UserProfile.id,
                    notificationMessageType: 'USER_NOTIFICATION',
                    pageIndex: 1,
                    pageSize: self.options.pageSize

                },
                success: function(json) {
                    Util.data('cache.msgList', json.data);
                    Widget.popupLoadingClose();

                    StageManager.pushView(view);
                }
            });
        }
    })
};
Views.MsgCenterView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'MsgCenterView',
        name: '消息中心',
        pageIndex: 1,
        pageSize: 20
    },
    willShow:function(ct) {
        var msgTypes = Util.data('cache.msgTypes'),
            msgType = Util.data('cache.msgType'),
            msgList = Util.data('cache.msgList');
        this.render(ct,{
            data: msgTypes,
            selectType: msgType,
            msgList: msgList
        });
        this.loadHtml();
    },
    didShow : function(){
        var self = this;
        this.makeScrollableWithPullRefresh($('#noticesBody'),{
            onPullUpRefresh: function() {
                Widget.popupToast('onPullUpRefresh');
            },
            onPullDownRefresh: function() {
                self.options.pageIndex = 1;
                var  hospital = Util.data('hosptial') ? Util.data('hosptial') : 'GRINM'  , hospitalId;
                if(hospital == 'GRINM'){
                    hospitalId = HOSPITAL_ID ;
                }else{
                    hospitalId = BRANCH_HOSPITAL_ID ;
                }
                FuckHttp.getMsgByType({
                    data: {
                        hospitalId: hospitalId,
                        accountId: UserProfile.id,
                        notificationMessageType:'USER_NOTIFICATION',
                        pageIndex: 1,
                        pageSize: self.options.pageSize

                    },
                    success: function(json) {
                        Util.data('cache.msgList', json.data);
                        Widget.popupLoadingClose();
                        self.loadHtml();
                    }
                });

//                zhicall.HttpPost.ajax('getMsgByType',[], {
//                    accountId: zhicall.session.id,
//                    WidgetMessageType: Util.data('cache.msgType')
//                }).send({
//                    success: function(json) {
//                        Util.data('cache.msgList', json.data);
//                        Widget.popupLoadingClose();
//                        self.loadHtml();
//                    }
//                });
            }
        });
    },
    loadHtml : function(){
        var data = Util.data('cache.msgList');
        $('#msgList').html(Views.tmpl.MsgCenterListView({
            msgList:  data || []
        }));

        if(data.length > 0){
            $('.ui-pullUp').removeClass('ui-hidden');
        }else {
            $('.ui-pullUp').addClass('ui-hidden');
        }
    },
    loadMoreHtml : function(data){
        if(data && data.length > 0){
            $('#msgList').append(Views.tmpl.MsgCenterListView({
                msgList: data || []
            }));
            $('.ui-pullUp').removeClass('ui-hidden');
        }else {
            $('.ui-pullUp').addClass('ui-hidden');
        }

    }
});
Views.MsgCenterListView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'MsgCenterListView',
        name: '消息中心'
    }
});
Callback.loadMoreMsg = function(){
    var self = StageManager.getCurrentView();
    self.options.pageIndex = self.options.pageIndex + 1;
    var  hospital = Util.data('hosptial') ,hospitalId ;
    if(hospital == 'GRINM'){
        hospitalId = HOSPITAL_ID ;
    }else{
        hospitalId = BRANCH_HOSPITAL_ID ;
    }
    FuckHttp.getMsgByType({
        data: {
            hospitalId: hospitalId,
            accountId: UserProfile.id,
            notificationMessageType:  'USER_NOTIFICATION',
            pageIndex: self.options.pageIndex,
            pageSize: self.options.pageSize
        },
        success: function(json) {
            var data = Util.data('cache.msgList');

            Widget.popupLoadingClose();
            self.loadMoreHtml(json.data);
            Util.data('cache.msgList', data.concat(json.data));
        },
        doneError: function(json){
            Widget.popupLoadingClose();
            Widget.alert(json.errMsg, function(){
                self.loadMoreHtml([]);
            });
        }
    });

};
Callback.ChangeMsgType = function(btnId){

    var btn = $('#'+btnId),
        type = btn.attr('data-rel'),
        hospital = btn.attr('data-hospital'),
        self = StageManager.getCurrentView( ) , hospitalId;
    if(btn.hasClass('selected')){
        return
    }
    $('.switch-btn.selected').removeClass('selected');
    btn.addClass('selected');
//    Util.data('cache.msgType', type);
    self.options.pageIndex = 1;
    if(hospital == 'GRINM'){
        hospitalId = HOSPITAL_ID ;
        Util.data('hosptial','GRINM');
    }else{
        hospitalId = BRANCH_HOSPITAL_ID ;
        Util.data('hosptial','BRANCH');
    }
    FuckHttp.getMsgByType({
        data: {
            hospitalId: hospitalId,
            accountId: UserProfile.id,
            notificationMessageType: 'USER_NOTIFICATION',
            pageIndex: self.options.pageIndex,
            pageSize: self.options.pageSize
        },
        success: function(json) {
            Util.data('cache.msgList', json.data);
            Widget.popupLoadingClose();
            self.loadHtml();
        }
    });
};

Callback.readMsg = function(btnId){
    var id = $('#'+btnId).attr('data-rel');
    var msgInfo = UserProfile.findMsgById(id);
    if(msgInfo){
        Util.data('cache.msgInfo', msgInfo);
        UserProfile.readMsgByCache(id);
        StageManager.pushView(Views.MsgCenterDetailView);

        if(msgInfo.readOrNot === 'NO'){
            FuckHttp.readMsg({
                data: {
                    id: id
                },
                success: function(json) {
                    Util.log('read msg success')
                },
                doneError: function(){
                    Util.log('read msg fail')
                }
            })
        }
    }
};

Callback.deleteMsg = function(btnId){
    var id = $('#'+btnId).attr('data-rel'),
        type = $('#'+btnId).attr('data-type');
    Util.confirm('确认删除？', function(index){
        if(index === 2){
            FuckHttp.deleteMsg({
                data: {
                    id: id
                },
                success: function(json) {
                    Widget.popupLoadingClose();
                    UserProfile.deleteMsgByCache(id);
                    Util.alert('删除成功！', function(){

                        if(type === 'list'){
                            var item = $('#'+btnId).closest($('.record-item'));
                            item.remove();
                        }else{
                            Callback.pageBack();
                        }
                    })
                }
            })
        }
    })
};
Views.MsgCenterDetailView = $.extend({}, Views.PanelView, {
    options: {
        tmpl: 'MsgCenterDetailView',
        name: '消息详情'
    },
    willShow : function(ct) {
        var msgTypes = Util.data('cache.msgTypes'),
            msgType = Util.data('cache.msgType'),
            msgList = Util.data('cache.msgList'),
            msgInfo = Util.data('cache.msgInfo');
        this.render(ct,{
            data : msgInfo
        });
    },
});