// ------------------------------------------------------------------------
// AppManager
// 
var AppManager = {
	// 打开app后的初始化
	initialize: function() {
		StageManager.initialize();
        initPaperType();
		Util.data('index.mainView', 0);
        StageManager.pushView(Views.mainView);
		FSManager.initialize();
		
		if (mobile_system) {
			// 使用手动方式控制启动画面，只有在js啥的都初始化完成后才隐藏之
			// 参考：http://docs.phonegap.com/en/2.2.0/cordova_splashscreen_splashscreen.md.html#Splashscreen
			setTimeout(function() {
				navigator.splashscreen.hide();
                FuckHttp.getAPPNote({
                    success: function(json){
                        var data = Util.data('appNote');
                        if(!data || data.createTime < json.data.createTime || !Util.data('showAppNote')){
                            Util.data('appNote', json.data);
                            Util.alertWindow(json.data);
                        }
                    },
                    doneError: function(json){

                    }
                });
			}, 1000);
		}else{
            FuckHttp.getAPPNote({
                success: function(json){
                    var data = Util.data('appNote');
                    if(!data || data.createTime < json.data.createTime || !Util.data('showAppNote')){
                        Util.data('appNote', json.data);
                        Util.alertWindow(json.data);
                    }
                },
                doneError: function(json){

                }
            });
        }
	}
};

var mscroller;
Callback.showDateMobiscroll = function(btnId) {
	Util.log('showDateMobiscroll');
	mscroller = $('#'+btnId);
	var type = mscroller.attr('type'), display = mscroller.attr('display') || 'bottom';

	if( !type )
		return;
	if( type === 'datetime-local' || type === 'datetime' ) {
		mscroller.mobiscroll().datetime({
			theme: 'ios7',
			lang: 'zh',
			display: display,
			mode: 'scroller',
			dateFormat: 'yyyy-mm-dd',
			dateOrder: 'yymmdd',
			dayText: '日', monthText: '月', yearText: '年', 
			maxDate: new Date()
		});
	} 
	if( type === 'date' ) {
		mscroller.mobiscroll().date({
			theme: 'ios7',
			lang: 'zh',
			display: display,
			mode: 'scroller',
			dateFormat: 'yyyy-mm-dd',
			dateOrder: 'yymmdd',
			dayText: '日', monthText: '月', yearText: '年', 
			maxDate: new Date()
		});
	}
    mscroller.mobiscroll('show');
};

// ------------------------- mainView
//
Views.mainView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'mainView',
		name: '首页',
        id: 'mainView'
	},

	subViews: ['hospitalServiceView','medicalGuideView','medicalInfoView','personalCenterView','moreView'],
    subViewTitles: ['福建省立医院','就医服务','关于医院', '个人中心','更多'],

	willShow: function(ct) {
		var index = Util.data('index.mainView') || 0;

		if ( index-0 === 3 ){
            if( !UserProfile.isUserLoggedIn() ) {
                Util.data('index.mainView', 0);
                StageManager.pushView(Views.loginView);
                return;
            }
        }

		this.render(ct, {
			appName: APPNAME,
			index: index
		});
        this.scroller = this.makeScrollable($('.ui-page-body', ct));
		this.addSubView(index);
	},

	didShow: function(ct) {
		this.isReady = true;
	},

	willHide: function() {
		this.$super().willHide();
		this.isReady = false;
	},

	onPageBack: function(transitionEndCallback) {
		if (APPVERSION !== 'wechat' && mobile_system === 'android' && this.isReady) {
			// 在android系统上，首页按“回退”键退出系统
			Util.confirm('您确定要退出' + APPNAME + '吗？', function(index) {
				if (index === 2) {
					if (Util.statisticEnabled) Util.statistic.onAppExit();
					navigator.app.exitApp();
				}
			});
		}
	},

	addSubView: function(index) {
		if(index-0 === 3){
            if( !UserProfile.isUserLoggedIn() ) {
                Util.data('index.mainView', 0);
                StageManager.pushView(Views.loginView);
                return;
            }
        }
	
		var subView =  Views[this.subViews[index]],
			cIndex = Util.data('index.mainView'),
			cSubView = Views[this.subViews[cIndex]],
			_dom = $('#mainView > .ui-page-body .ui-scroller');

		if( subView && subView.show  ) {
			subView.show(_dom);
            this.scroller.scrollTo(0, 0)
			Util.data('index.mainView',index);
		}

		if( cIndex === 0 && index !== 0 ) {
			if( cSubView && cSubView.hide ) {
				cSubView.hide();
			}
		}

		$('.ui-header-title').html(this.subViewTitles[index]);
        if(!Util.data('needCourse')){
            Util.data('needCourse', true);
            Util.confirm('是否查看新手教程？', function(index){
                if(index === 2){
                    StageManager.pushView(Views.NoviceCourseView);
                }
            })
        }
	},

	refreshSubView: function() {
		var index = Util.data('index.mainView'),
			subView =  Views[this.subViews[index]],
			_dom = $('#mainView > .ui-page-body');

		if( subView && subView.show  ) {
			subView.show(_dom);
		}
	}

});
Callback.switchMainTabView = function(btnId) {
	var _btn = $('#' + btnId),
		index = _btn.attr('data-rel') - 0,
		_cIndex = Util.data('index.mainView');

    Util.data('contactType','');
	if( index !== _cIndex ) {
		Views.mainView.addSubView(index);
		_btn.addClass('selected').siblings('.item').removeClass('selected');
	}
	
};
Callback.showNotOpen = function(){
    Widget.popupToast('功能建设中,敬请期待！');
};
Views.mainSubView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: '',
		name: '主页的子页面'
	},

	willShow: function(ct) {
		Util.log('mainSubView willShow!');
		return {};
	},

	didShow: function(data) {
		Util.log('mainSubView didShow!');
	},

	show: function(ct) {
		var data = this.willShow(ct);
		this.render(ct, data);
		this.didShow(data);
	},

	willHide: function() {
		Util.log('mainSubView willHide!');
	},

	didHide: function() {
		Util.log('mainSubView didHide!');
	},

	hide: function() {

	}
});

// ------------------------- 首页 > 就医服务
//
Views.hospitalServiceView = $.extend({}, Views.mainSubView, {
	options: {
		tmpl: 'hospitalServiceView',
		name: '首页-就医服务'
	},

	banners: [
		{url: 'themes/images/banner/1.jpg',note: '福建省立医院'}, 
		{url: 'themes/images/banner/2.jpg',note: '一站式杂交手术室'}, 
		{url: 'themes/images/banner/3.jpg',note: '掌上医院上线'}
	],

	willShow: function(ct) {
		this.container = ct;

		var navopts = this.calcNavLayout();
		navopts.banners = this.banners;

		navopts.width = Layout.windowWidth;

		return navopts;
	},

	didShow: function(data) {
		if (this.bannerScroller) {
			this.viewScrollerDestroy(this.bannerScroller);	
		}
		if (this.bannerCarouselTid) {
			clearTimeout(this.bannerCarouselTid);
		}
		
		var self = this;
		this.bannerScroller = this.makeScrollable($('.scroller'), {
			snap: true,
			momentum: false,
			hScrollbar: false,
			onScrollEnd: function() {
				var currPageX = this.currPageX,
					noteTxt = self.banners[currPageX].note;

				if( self.container ) {
					self.container.find('.banner .indicator li.active').removeClass('active');
					self.container.find('.banner .indicator li:nth-child(' + (currPageX+1) + ')').addClass('active');
					self.container.find('.banner .note').html(noteTxt);
				}
				
				self._resetBannerCarousel();
			}
		});
		this._resetBannerCarousel();
	},

	hide: function() {
//		this.container = null;
//		this.bannerScroller = null;

//		if (this.bannerCarouselTid)
//			clearTimeout(this.bannerCarouselTid);
	},

	_resetBannerCarousel: function() {
//		if (this.bannerCarouselTid)
			clearTimeout(this.bannerCarouselTid);

		var self = this;
		this.bannerCarouselTid = setTimeout(function() {
			if (!self.bannerScroller) {
				clearTimeout(self.bannerCarouselTid);
				self.bannerCarouselTid = null;
				return;
			}
			
			var currPageX = self.bannerScroller.currPageX;
			if (currPageX === 2) {
				self.bannerScroller.scrollToPage(0, 0, 500);
			} else {
				self.bannerScroller.scrollToPage('next', 0);
			}
		}, 5000);
	},

	onResize: function(w, h) {
		if (!this.container) return;

		var navopts = this.calcNavLayout();
		navopts.banners = this.banners;

		this.viewScrollerDestroyAll();
		this.show(this.container);
	},

	calcNavLayout: function() {
		var cw = Layout.windowWidth,
			ch = ( Layout.windowHeight-44-50-Layout.statusBarMargin ) - Math.round(cw*0.4),
			marginW = 6,
			marginH = 6,
			result = {};

		if ( Layout.windowHeight > 450 ) {
			marginH += ( Layout.windowHeight - 450 )/18;
		}

		result.marginW = marginW;
		result.marginH = marginH;
		result.imgW = ( cw-marginW*6 )/2;
		result.imgH = ( ch-marginH*6 )/2;

		return result;
	}
});

// ------------------------- 首页 > 导医服务
//
Views.medicalGuideView = $.extend({}, Views.mainSubView, {
	options: {
		tmpl: 'medicalGuideView',
		name: '首页-导医服务'
	}
});


// ------------------------- 首页 > 信息查询
//
Views.medicalInfoView = $.extend({}, Views.mainSubView, {
	options: {
		tmpl: 'medicalInfoView',
		name: '首页-信息查询'
	}
});

// ------------------------- 首页 > 个人中心
//
Views.personalCenterView = $.extend({}, Views.mainSubView, {
	options: {
		tmpl: 'personalCenterView',
		name: '首页-个人中心'
	},
	willShow: function(ct) {
		return {
			code: UserProfile.code
		};
	},
	didShow: function(){
		this.makeScrollable($('#personalCenterScroller'));
    }
});

// ------------------------- 首页 > 更多
Views.moreView = $.extend({}, Views.mainSubView, {
	options: {
		tmpl: 'moreView',
		name: '首页-更多'
	},

	willShow: function(ct) {
		return {
			version: VERSION_NUMBER
		};
	}
});


// ------------------------- 自助服务
//
Views.diyServiceView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'diyServiceView',
		name: '自助服务'
	},

	willShow: function(ct) {
		this.render(ct);
	}
});

// ------------------------- 报告查询
//
Views.reportInqueryView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'reportInqueryView',
		name: '报告查询'
	},

	willShow: function(ct) {
		this.render(ct);
	}
});





// ------------------------- 专家简介
//
Callback.showExpertInfoView = function(btnId) {
	var btn = $('#'+btnId), departId = btn.attr('depart-id'), doctorId = btn.attr('doctor-id');
	var depart = TestSuit.scheduleSearchResultData()[departId-0], doctors = depart.doctors;
	
	delete depart.doctors;
	Util.data('expertInfoView.depart',depart);
	
	for( var i=0;i<doctors.length;i++ ) {
		if( doctors[i].id === doctorId-0 ) {
			Util.data('expertInfoView.doctor',doctors[i]);
			StageManager.pushView(Views.expertInfoView);
			return;
		}
	}
};
Views.expertInfoView = $.extend({}, Views.PanelView, {
	options: {
		tmpl: 'expertInfoView',
		name: '专家简介'
	},

	willShow: function(ct) {
		this.render(ct,{
			depart: Util.data('expertInfoView.depart'),
			doctor: Util.data('expertInfoView.doctor')
		});
		this.makeScrollable(ct.find('.ui-page-body'));
		ct.find('.expert-schedule').html(Views.tmpl.regScheduleTableSubView());
	}
});

Callback.showDepartListViewForDepartSchedule = function() {
	Views.departListView.showForDepartSchedule();
};
Callback.showDepartListViewForExpertSchedule = function() {
	Views.departListView.showForExpertSchedule();
};
Callback.departSearchClearInput = function(btnId) {
	$('input.search-input').val('');
	$('#' + btnId).addClass('ui-hidden');
	Views.departListView.filterDeparts('');
};
Callback.showDepartSchedule = function(btnId) {
	Views.departListView.toggleDepartSchedule(btnId);
};
Callback.showDepartExpertList = function(btnId) {
	var _btn = $('#' + btnId);
	Views.scheduleSearchResultView.showByDept(_btn.attr('data-rel'));
};

// ------------------------- 缴费充值
//
Views.rechargeView = $.extend({},Views.PanelView, Views.costRecordView);
Views.rechargeView = $.extend(Views.rechargeView, {
    options: {
        tmpl: 'rechargeView',
        name: '缴费充值',
        id: 'mzSettleRecordView',
        dataKey: 'mzSettleRecordView.member',
        ajaxFun: 'ajaxMzSettleRecords',
        refreshFun: 'ajaxMzSettleRecords'
    },

    willShow: function(ct) {
        var card = Util.data('cache.card');
        if(!card || !card.id){
            Util.data('cache.card', '')
        }
        var type = Util.data('rechargeViewType');
        var title = '充值结算';
        var typeObj = {
            'mzRecharge': '门诊充值',
            'mzSettle': '门诊结算',
            'zyRecharge': '住院充值'
        };
        var hasChooseItem = Util.data('hasChooseItem');
        if(!hasChooseItem){
            title = typeObj[type];
        }
        this.render(ct,{
            card: Util.data('cache.card'),
            member: Util.data('cache.personalInfo'),
            type: Util.data('rechargeViewType'),
            hasChooseItem: hasChooseItem,
            title: title
        });
        this.showByType();
//        this.makeScrollable($('.ui-page-body',ct));
//        this.getCardBalance();
    },
    getRechargeRange: function(callback){
        var type = Util.data('rechargeViewType'), param;
        if(type === 'mzRecharge'){
            param = 'OUTPATIENT';
        }else if(type === 'zyRecharge'){

            param = 'INPATIENT';
        }
        FuckHttp.getRechargeRange({
            data: {
                type: param
            },
            success: function(json){
                Widget.popupLoadingClose();
                Util.data('rechargeRange', json.data);
                callback();
            }
        });
    },
    showByType: function(){
        var type = Util.data('rechargeViewType');
        var self = Views.rechargeView, callback;
        if(this.viewScroller){
            this.viewScrollerDestroy(this.viewScroller);
        }
        if(type === 'mzRecharge'){
            callback = function(){
                $('#content').html(Views.tmpl.rechargeSubView({
                    card: Util.data('cache.card'),
                    member: Util.data('cache.personalInfo'),
                    type: type,
                    fee: Util.data('rechargeFee'),
                    rechargeRange: Util.data('rechargeRange')
                }));
                self.viewScroller = self.makeScrollable($('.ui-page-body.reg-info-confirm'));
                self.getCardBalance();
            };
            this.getRechargeRange(callback);

        }else if(type === 'mzSettle'){
            $('#content').html(Views.tmpl.rechargeSubView({
                type: type,
                card: Util.data('cache.card'),
                member: Util.data('cache.personalInfo'),
                hasChooseItem: Util.data('hasChooseItem')
            }));
            this.viewScroller = this.makeScrollableWithPullRefresh($('#reg-records'),{
                onPullUpRefresh: function() {
                    Widget.popupToast('onPullUpRefresh');
                },
                onPullDownRefresh: function() {
                    var member = Util.data('cache.personalInfo');
                    Util.data(self.options.dataKey+member.id, '');
                    self.ajaxRegs(function(data){
                        if( data && data.length > 0 ) {
                            $('.ui-pullUp').removeClass('ui-hidden');
                        } else {
                            $('.ui-pullUp').addClass('ui-hidden');
                        }
                        $('.ui-pullUp').addClass('ui-hidden');
                    }, 'index');
                }
            });
            this.ajaxRegs(function(data){
                if( data && data.length > 0 ) {
                    $('.ui-pullUp').removeClass('ui-hidden');
                } else {
                    $('.ui-pullUp').addClass('ui-hidden');
                }
                $('.ui-pullUp').addClass('ui-hidden');
            }, 'index');
//            Views.mzSettleRecordView.
        }else if(type === 'zyRecharge'){
            callback = function(){
                $('#content').html(Views.tmpl.rechargeSubView({
                    card: Util.data('cache.card'),
                    member: Util.data('cache.personalInfo'),
                    type: type,
                    rechargeRange: Util.data('rechargeRange')
                }));
                self.getCardBalance();
                self.viewScroller = self.makeScrollable($('.ui-page-body.reg-info-confirm'));
            };
            this.getRechargeRange(callback);
        }
    },
    didShow: function(ct){
//        if(UserProfile.findTrueCards().length === 0){
//            Util.confirm('您还没有添加就诊卡，是否添加就诊卡？', function(index) {
//                if (index === 2) {
//                    Callback.showMemberListView();
//                }
//            });
//        }
    },
    getCardBalance: function(){
        var self = this;
        this.canRecharge = false;
        var card = Util.data('cache.card');
        if(!card){
            $('#balance').html('');
        }else {
            $('#balance').html('正在获取...');
            var data = {
                hospitalId: HOSPITAL_ID,
                medicalCardId: card.id
            };
            FuckHttp.getCardBalance({
                data: data,
                success: function(json) {
                    $('#balance').html('￥' + json.data);
                    Util.data('cardBalance', json.data);
                    self.canRecharge = true;
                },
                doneError: function(json) {
                    $('#balance').html('查询失败');
                    self.canRecharge = false;
                    Util.data('cardBalance', '');
                }
            });
        }
    },
    ajaxRegs: function(callback, type) {
        var self = this, member = UserProfile.getCurrentMember(), url, param = {deviceId: DEVICE_UUID, version: VERSION_NUMBER, hospitalId: HOSPITAL_ID};
        if( type === 'index' ) {
            Util.log('');
        } else if ( type === 'more' ) {
            param.yearMonth = this.currentMouth;
        }
        if( APPVERSION === 'web' ) {
            setTimeout(function(){
                self.loadHtml(TestData.timeRegs, type);
                if(callback) callback(TestData.timeRegs);
            },600);
        } else {
            if(!member || !member.id){
                Util.data('cache.personalInfo', '');
                Widget.popupToast('请先选择就诊卡');
                self.loadHtml([], type);
                return;
            }
            var data= {
                patientId: member.id
            };
            if(type === 'more'){
                data.yearMonth = self.currentMouth;
            }
            FuckHttp[self.options.ajaxFun]({
                memberId: member.id,
                data: data,
                doneError: function(json) {
                    if (json.data === -1) {
                        Util.confirm(json.errMsg, function(index) {
                            if (index === 2) {
                                // StageManager.pushView(Views.memberListView);
                                Callback.showMemberChoose();
                            }
                        });
                    } else {
                        Util.alert(json.errMsg);
                    }

                    if( type === 'index' ) {
                        Util.data(self.options.dataKey+member.id, '');
                        self.loadHtml([], type);
                    }

                    if(callback) callback();
                },
                success: function(json) {
                    var data = $.isArray(json.data) ? json.data : [json.data];
                    if( json.data ) {
                        self.currentMouth = data[0].monthName;
                    } else {
                        Util.alert('没有记录');
                    }
                    if( type === 'index' ) {
                        Util.data(self.options.dataKey+member.id, data);
                    }else{
                        var oldData = Util.data(self.options.dataKey+member.id);
                        Util.data(self.options.dataKey+member.id, oldData.concat(data));
                    }
                    self.loadHtml(data, type);
                    if(callback) callback(data);
                },
                error: function() {
                    if(callback) callback();
                }
            });
        }
    },
    loadHtml: function(data, type) {
        if( type === 'index' ) {
            $('.reg-records-list').html(Views.tmpl.recordListView({
                title: this.options.name,
                modal: type,
                regs: data,
                type: this.options.id
            }));
        } else if( type === 'more' ) {
            $('.reg-records-list').append(Views.tmpl.recordListView({
                title: this.options.name,
                modal: type,
                regs: data,
                type: this.options.id
            }));
        }
    }
});
Callback.changeSettleType = function(btnId, theType){

    var type = $('#'+btnId).attr('data-rel');
    var oldType = Util.data('rechargeViewType');
    if(type === oldType){
        return;
    }
//    if(type === 'zyRecharge'){
//        var card = Util.data('cache.card');
//        if(!card || card.medicalCardType !== '住院号'){
//            Util.data('cache.card', UserProfile.findTrueCards('住院号')?UserProfile.findTrueCards('住院号')[0] : '');
//        }
//    }else{
//        var card = Util.data('cache.card');
//        if(!card || card.medicalCardType === '住院号'){
//            Util.data('cache.card', UserProfile.findTrueCards()?UserProfile.findTrueCards()[0] : '');
//        }
//    }
    if(theType && typeof theType!== 'object'){
        Util.data('rechargeViewType', theType);
        $('.choose-item-title .left-item.sel').removeClass('sel');
        $('.choose-item-title .left-item:first-child').addClass('sel');
        Views.rechargeView.showByType();
        return;
    }
    Util.data('rechargeFee', '');
    Util.data('cache.card', '');
    $('.choose-item-title .left-item.sel').removeClass('sel');
    $('#'+btnId).addClass('sel');
    Util.data('cache.personalInfo', '');
    Util.data('rechargeViewType', type);
    Views.rechargeView.showByType();
};
Callback.showRechargeView = function(hasChooseItem){
    if (!UserProfile.isUserLoggedIn()) {
        Util.alert('使用此功能，请先登录！',function(){
            StageManager.pushView(Views.loginView);
        });
        return
    }

//    var card = Util.data('cache.card');
//    if(!card || card.medicalCardType === '住院号'){
//        Util.data('cache.card', UserProfile.findTrueCards()?UserProfile.findTrueCards()[0] : '');
//    }
    var type = 'mzRecharge';
    Util.data('rechargeViewType', type);
    Util.data('rechargeFee', '');
//    if(!hasChooseItem){
//        Util.data('hasChooseItem', true);
//    }else{
//        Util.data('hasChooseItem', false);
//    }
    Util.data('hasChooseItem', true);
    Util.data('cache.card', '');

    StageManager.pushView(Views.rechargeView);

};
Callback.goBackToSettle = function(btnId){
    var array = [],
        member = UserProfile.getCurrentMember();
    if ($('#' + btnId).attr('data-rel') == 'zyRecharge') {
        Util.data('infoType', 'zyRechargeRecordView');
        Util.data(Views.zyRechargeRecordView.options.dataKey + member.id, '');
        array = [Views.mainView, Views.zyServiceView, Views.zyRechargeRecordView, StageManager.getCurrentView()];
    } else if ($('#' + btnId).attr('data-rel') == 'mzRecharge'){
        Util.data('infoType', 'rechargeRecordView');
        Util.data(Views.rechargeRecordView.options.dataKey + member.id, '');
        array = [Views.mainView, Views.menzhenServiceView, Views.rechargeRecordView, StageManager.getCurrentView()];
    } else {
        array = [Views.mainView, Views.menzhenServiceView, Views.rechargeView, StageManager.getCurrentView()];
    }
    StageManager.fixViewStack(array, function() {
        Callback.pageBack();
    });
};
Callback.showRechargeSettleView = function(btnId){
    if (!UserProfile.isUserLoggedIn()) {
        Util.alert('使用此功能，请先登录！',function(){
            StageManager.pushView(Views.loginView);
        });
        return
    }
    var type = $('#'+btnId).attr('data-rel');
    Util.data('rechargeViewType', type);
    Util.data('hasChooseItem', false);

    Util.data('cache.card', '');
    Util.data('cache.personalInfo', '');

//    if(type === 'zyRecharge'){
//        var card = Util.data('cache.card');
//        if(!card || card.medicalCardType !== '住院号'){
//            Util.data('cache.card', UserProfile.findTrueCards('住院号')?UserProfile.findTrueCards('住院号')[0] : '');
//        }
//    }else{
//        var card = Util.data('cache.card');
//        if(!card || card.medicalCardType === '住院号'){
//            Util.data('cache.card', UserProfile.findTrueCards()?UserProfile.findTrueCards()[0] : '');
//        }
//    }

    StageManager.pushView(Views.rechargeView);
};
Callback.chooseMoneyAmount = function(btnId){
    var amount = $('#'+btnId).attr('data-rel')-0;
    $('#amount').val(amount);
};
Callback.doRecharge = function(){
    var amount = $('#amount').val() - 0,
        card = Util.data('cache.card');
    var type = Util.data('rechargeViewType'),
        msg = '就诊卡';
    if(type === 'zyRecharge'){
        msg = '住院号';
    }
    StageManager.getCurrentView().options.type = type;
    if(!card || !card.id){
        Widget.popupToast('请先选择'+msg);
        return;
    }
    var cardBalance = Util.data('cardBalance');
    if(!Views.rechargeView.canRecharge || !cardBalance){
        Widget.popupToast('请查询余额成功后再充值');
        return;
    }
    if(isNaN(amount)){
        Widget.popupToast('请输入正确的金额');
        return;
    }
    if(!amount){
        Widget.popupToast('请输入充值金额');
        return;
    }

    var rechargeRange = Util.data('rechargeRange');



    if(APPVERSION === 'product' || APPVERSION === 'debug'){
        if(Util.data('rechargeViewType') === 'zyRecharge'){
            if((cardBalance - 0 + amount) > rechargeRange.maximum-0 || amount < rechargeRange.minimum-0 - cardBalance){
                Widget.popupToast('账户余额+住院充值金额范围'+ rechargeRange.minimum + '~'+ rechargeRange.maximum + '元');
                return;
            }
        }else{
            if(Util.data('rechargeFee')){

            }else if(( cardBalance - 0 + amount) > rechargeRange.maximum-0 || amount < rechargeRange.minimum-0-cardBalance){
                Widget.popupToast('账户余额+门诊充值金额范围'+ rechargeRange.minimum + '~'+ rechargeRange.maximum + '元');
                return;
            }
        }
    }

    var data = {
        hospitalId: HOSPITAL_ID,
        accountId: UserProfile.id,
        medicalCardId: card.id,
        fee: amount
    };
    Util.confirm(msg + card.medicalCardNo + '本次充值金额为'+ data.fee + '元，是否确认充值？', function(index){
        if(index === 2){
//            FuckHttp.checkOperatorBill({
//                data: {payType; //支付类型   1门诊   2 住院
//            String payPlatform;
//        }
//            });
            FuckHttp.doRecharge({
                data: data,
                success: function(json) {
                    Widget.popupLoadingClose();
                    Util.alert(json.errMsg, function(){
//                StageManager.getCurrentView().getCardBalance();
                        Callback.commonPay(json);
                    });
                }
            })
        }
    })
};

Callback.commonPay = function(json){
    Util.data('recharge.order', json.data);
    var data = {
        trade_no: json.data.tradeNo,
        partner_sign: json.data.partnerSign
    };
    Util.data("cache.selectPayViewData",data);

    var flag;
    Widget.popupLoading('正在初始化支付...');

    $.ajax({
        async:false,
        type: 'POST',
        url: PAYMENT_QUERY_URL,
        data: {
            partner_sign: data.partner_sign,
            trade_no: data.trade_no,
            pay_platform: ''
        },
        timeout: 10000,
        dataType: 'json'
    }).done(function (json, textStatus, jqXHR) {
        Widget.popupLoadingClose();
        flag = true;
        Util.data('cache.tradeFee', json.trade_fee);
    }).fail(function (jqXHR, textStatus, errorThrown) {
        flag = false;
        Widget.popupLoadingClose();
        Util.alert('网络繁忙，请重试:-(');
    });
    if (flag === true) {
        StageManager.pushView(Views.selectPayWayView);
    } else {
        return;
    }
};

Callback.payCallBck = function(param){
    Widget.popupLoadingClose();
    var infoType = Util.data('cache.infoType');
    if (param.trade_status !== '000') {
        Util.alert('支付失败，请重新支付！',function(){
            Callback.pageBack();
        });
        return;
    }
    //配送预约
    if (Util.data('recharge.order').way == 'reservation') {

        FuckHttp.reservationRecord({
            data: {
                sendStatus : ''
            },
            success: function(json) {
                Util.data('caseRecordView', json.data);
                reservationChangeStatus();
            }
        });

        return;
    }

    var outTradeNo = Util.data('recharge.order').outTradeNo;

    FuckHttp.ajaxChargeResult({
        data: {
            zhpChargeSerialNo: outTradeNo,
            hospitalId: HOSPITAL_ID
        },
        success: function(json) {
            Widget.popupLoadingClose();
            Util.data('rechargeFee', '');
            Util.data('cache.recordDetailId', json.data.base.id);
            var msg = '';
            if(json.data.base.status === 'SUCCESS'){
                msg = '充值成功！';
                var feeStr = '您本次成功充值'+ json.data.base.fee + '元';
                Widget.popupLoading('正在查询结果...');
                FuckHttp.getCardBalance({
                    data: {
                        hospitalId: HOSPITAL_ID,
                        medicalCardId: Util.data('cache.card').id
                    },
                    success: function(json) {
                        Util.alert(msg);
                        var balanceStr = '，当前账户余额为'+ json.data +'元。';
                        $('#rechargeInfo').html(feeStr + balanceStr);
                    },
                    doneError: function(json) {
                        $('#result-icon').removeClass('success').addClass('error');
                        Util.alert(msg);
                        Util.log('账户余额查询失败');
                        var balanceStr = '。';

                    }
                });
            }else{
                if (json.data.base.status === 'HISEXCEPTION') {
                    Util.alert('充值异常，请查询充值记录确认是否成功');
                    $('#result-icon').removeClass('success').addClass('error');
                    $('#rechargeInfo').html('充值异常，请查询充值记录确认是否成功');
                    return;
                }
                msg = '网络繁忙，请查询充值记录确认是否成功';
                Util.alert(msg,function(){
                    StageManager.fixViewStack([Views.mainView, Views.rechargeView, StageManager.getCurrentView()], function(){
                        Callback.pageBack();
                    });
                });
            }
        },
        doneError: function(json){
            Util.data('rechargeFee', '');
            var type = Util.data('rechargeViewType');
            var msg = '充值失败';
            if(type === 'zyRecharge'){
                msg = '充值失败，请联系0591-88217807(住院部)';
            }else{
                msg = '充值失败，请联系0591-88217806(门诊部)'
            }
            Util.alert(msg,function(){
                StageManager.fixViewStack([Views.mainView, Views.rechargeView, StageManager.getCurrentView()], function(){
                    Callback.pageBack();
                });
            });
        }
    });
};
Callback.showMzServiceView = function(){
//    if (!UserProfile.isUserLoggedIn()) {
//        Util.alert('使用此功能，请先登录！',function(){
//            StageManager.pushView(Views.loginView);
//        });
//        return
//    }
    StageManager.pushView(Views.menzhenServiceView)
};
Callback.showZyServiceView = function(){
//    if (!UserProfile.isUserLoggedIn()) {
//        Util.alert('使用此功能，请先登录！',function(){
//            StageManager.pushView(Views.loginView);
//        });
//        return
//    }

    StageManager.pushView(Views.zyServiceView)
};
Callback.showCareAppointmentView = function(){

    if (!UserProfile.isUserLoggedIn()) {
        Util.alert('使用此功能，请先登录！',function(){
            StageManager.pushView(Views.loginView);
        });
        return
    }

    StageManager.pushView(Views.CareAppointmentView);
}


Callback.showRecordDetailView = function(outTradeNo) {
    var title,
        name,
        recordId = Util.data('cache.recordDetailId'),
        member = Util.data('cache.member'),
        param = Util.data('cache.clinic.param'),
        pageName = param?param.recordView:'';
    Util.log('pageName='+ pageName);
    if(!pageName){
        pageName = Util.data('cache.infoType');
    }



    Util.log('pageName='+ pageName);
    Util.data('cache.infoType', pageName);
    var recordListView = require('views.info.'+pageName);
    Util.data(pageName +'.data', '');
    Util.data('cache.oldMemberInfo', Util.data('cache.member'));

    name = require('views.info.'+ pageName).options.name;
    title = name + '详情';
    var data = zhicall.Cache.data(pageName+ '.data');

    FuckHttp.ajaxReChargeCardDetail({
        data: {},
        success: function(json) {
            Notification.popupLoadingClose();
            zhicall.Cache.data('recordDetail',{
                data: json.data,
                title: title,
                mode: pageName
            });
            recordListView.pushView('views.info.RecordDetailView');
            zhicall.Cache.data('IndexView.index', 0);
            StageManager.fixViewStack([
                require('views.index.IndexView'),
                require('views.service.RechargeCardView'),
                recordListView,
                StageManager.getCurrentView()
            ]);
        },
        doneError: function(json){
            Notification.popupLoadingClose();
            Notification.alert('获取'+ title + '失败，请至充值记录中查看', function(){
                StageManager.pushView(recordListView);
                zhicall.Cache.data('IndexView.index', 0);
                StageManager.fixViewStack([
                    require('views.index.IndexView'),
                    require('views.service.RechargeCardView'),
                    recordListView
                ]);
            });
        }
    });

};

Callback.showOnlineConsultation = function(){
    if (!UserProfile.isUserLoggedIn() || !Util.data('IM')) {
        UserProfile.setUserLogout();
        Util.alert('使用此功能，请先登录！',function(){
            StageManager.pushView(Views.loginView);
        });
        return
    }
    var accountInfo = Util.data('cache.accountInfo');
    delete accountInfo.accounts;
    if(!cordova){
        return;
    }
    cordova.exec(
        function(winParam) {},
        function(error) {

        },
        "OnlineConsultationPlugin",
        "showOnlineConsultation",
        []
    );
};

Callback.showLogout = function(){
    if(APPVERSION === 'web'){
        return;
    }
    if(!cordova){
        return;
    }
    cordova.exec(
        function(winParam) {},
        function(error) {

        },
        "OnlineConsultationPlugin",
        "action_intent_account_logout",
        []
    );
};

Callback.showLogin = function(){
    if(APPVERSION === 'web'){
        return;
    }
    var accountInfo = Util.data('cache.accountInfo');
    delete accountInfo.accounts;
    var IM = Util.data('IM');
    accountInfo.IM = IM;
    if(!cordova){
        return;
    }
    cordova.exec(
        function(winParam) {},
        function(error) {

        },
        "OnlineConsultationPlugin",
        "action_intent_account_login",
        [
            {
                mode: APPVERSION,
                hospitalId: HOSPITAL_ID,
                account: accountInfo
            }
        ]
    );
};

Callback.logout = function(btnId) {
    UserProfile.setUserLogout();
};

Callback.closeAlertWindow = function(){
    $('#alertWindow').remove();
};
Callback.showAppNote = function(btnId){
    var btn = $('#'+btnId);
    if(btn.hasClass('selected')){
        btn.removeClass('selected');
        Util.data('showAppNote', '');
    }else{
        btn.addClass('selected');
        Util.data('showAppNote', true);
    }
};